#!/bin/sh
# Script for applying startup-config 
# at first reboot after USB format

STFILE=/etc/startup-config
FIRST_INSTALL_FLAG=/etc/sysconfig/first_install
CLOUD_INIT_CLISH_CONFIG=/etc/sysconfig/cloud_init_clish_config

if [ -f $STFILE ]
then
	if [ ! -f $CLOUD_INIT_CLISH_CONFIG ]
	then
		# check if first installation
		if [ -f $FIRST_INSTALL_FLAG ]
		then
			# delete first-install flag file
			rm $FIRST_INSTALL_FLAG

			echo "Applying startup-config after format"

			# apply values	
			/sbin/system-config-clish-runtime
		fi
	else
		# only delete first-install flag file
		rm $FIRST_INSTALL_FLAG
	fi
fi

