#!/bin/sh

file=/tmp/running-config

if [ "$1" == "" ]
then
	# dump running-config to tmp file
	konf -- -d > $file
else
	# script was called with reboot option - dump startup-config
	file=/etc/startup-config
fi


# get basic system params
hostname=`grep "hostname" $file`
unit_node_id=`grep "system unit-id" $file`
sys_type=`grep "system type" $file`
chass_type_size=`grep "chassis type" $file`


if [ "$hostname" == "" ] || [ "$unit_node_id" == "" ] || [ "$sys_type" == "" ] || [ "$chass_type_size" == "" ]; then
	echo

	if [ "$hostname" == "" ]
	then
		echo "Error: Hostname not configured! Please configure hostname - command 'hostname'."
	fi

        if [ "$unit_node_id" == "" ]
        then
                echo "Error: System unit and node ID not configured! Please configure unit and node ID - command 'system unit-id'."
        fi

        if [ "$sys_type" == "" ]
        then
                echo "Error: System type not configured! Please configure system type - command 'system type'."
        fi

        if [ "$chass_type_size" == "" ]
        then
                echo "Error: Chassis type and size not configured! Please configure chassis type and size - command 'chassis'."
        fi

	echo
else
        echo ok
fi

if [ -f /tmp/running-config ]
then
rm /tmp/running-config
fi


