#!/bin/sh

# create route to remote unit - only if we are L3 GEO
# in runtime add route on system and interfaces file
# after reboot add route only in interface file

FILE=/etc/startup-config
INTERFACES=/etc/network/interfaces

if [ "$1" == "reboot" ]
then
	#get params from startup-config
	GW=`cat $FILE | grep 'ip route mgmt' | awk '{printf $6}'`
	GEO_TYPE=`cat $FILE | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'geo-type' | awk '{printf $2}'`
	GEO_ENABLE=`cat $FILE | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'enable'`
	GEO_REM_FLOAT=`cat $FILE | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'remote ip address mgmt float' | awk '{printf $6}'`
else
	# get params from running conf
	GW=`konf -- -d | grep 'ip route mgmt' | awk '{printf $6}'`
	GEO_TYPE=`konf -- -d | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'geo-type' | awk '{printf $2}'`
	GEO_ENABLE=enable
	GEO_REM_FLOAT=`konf -- -d | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'remote ip address mgmt float' | awk '{printf $6}'`
fi

if [ "$GEO_ENABLE" != "" ] && [ "$GEO_TYPE" == "L3" ]
then
	# calculate IP addr and mask from IP
	IP=`echo $GEO_REM_FLOAT`
	. /sbin/cfg-calculate-network.sh ${IP}
	convert_ip_mask

	# calculate SUBNET
	IFS=. read -r i1 i2 i3 i4 <<<"$IPN"
	IFS=. read -r m1 m2 m3 m4 <<<"$NMASK"

	NET=`printf "%d.%d.%d.%d" "$((i1 & m1))" "$((i2 & m2))" "$((i3 & m3))" "$((i4 & m4))"`

	if [ "$1" != "reboot" ]
	then
		#add route
		/sbin/route add -net $NET netmask $NMASK gw $GW
	elif [ -z "$(cat $INTERFACES | grep "up route add \-net" | grep $NET | grep $NMASK | grep $GW)" ]; then
		#add route to network/interfaces file
		echo "" >> $INTERFACES
		echo "up route add -net $NET netmask $NMASK gw $GW" >> $INTERFACES
	fi
fi

