#!/bin/sh

INPUT=$1

# if no dns command was executed
if [ "$2" != "delete" ] && [ "$1" != "domain" ]
then
	if [ "$1" != "" ]
	then
		NAMESERVER1T=`konf -- -d | grep 'dns-server primary' |awk '{print $3}'` 
		NAMESERVER2T=`konf -- -d | grep 'dns-server secondary' |awk '{print $3}'` 
		NAMESERVER3T=`konf -- -d | grep 'dns-server tertiary' |awk '{print $3}'` 
	fi
	
	if [ "$1" == "primary" ] 
	then
		NAMESERVER1T=$2
	fi
	if [ "$1" == "secondary" ] 
	then
		NAMESERVER2T=$2
	fi
	if [ "$1" == "tertiary" ] 
	then
		NAMESERVER3T=$2
	fi
	
	S1=`sed -n 5p /etc/bind/named.conf.options`
	if [ "$S1" != "" ]
	then
		NAMESERVER1=`sed -n 5p /etc/bind/named.conf.options | sed s/.$// | sed 's/ //g'`
	fi
	S2=`sed -n 6p /etc/bind/named.conf.options`
	if [ "$S2" != "" ]
	then
		NAMESERVER2=`sed -n 6p /etc/bind/named.conf.options | sed s/.$// | sed 's/ //g'`
	fi
	S3=`sed -n 7p /etc/bind/named.conf.options`
	if [ "$S3" != "" ]
	then
		NAMESERVER3=`sed -n 7p /etc/bind/named.conf.options | sed s/.$//  | sed 's/ //g'`
	fi
	
	# script is called within  configure-system-clish without parameters or runtime with parameters
	
	DOMAIN=$(/sbin/cfg-getparams.sh mmSystemConfigDomainName)
	if [ "$1" == "domain" ]
	then
		DOMAIN=$2
	fi
	
	if [ "$1" == "" ]
	then
		NAMESERVER1T=$(/sbin/cfg-getparams.sh mmNameServer1)
		NAMESERVER2T=$(/sbin/cfg-getparams.sh mmNameServer2)
		NAMESERVER3T=$(/sbin/cfg-getparams.sh mmNameServer3)
	fi
	
	NAMESERVER1=`echo ${NAMESERVER1T} | sed 's/ *\/.*//'`
	NAMESERVER2=`echo ${NAMESERVER2T} | sed 's/ *\/.*//'`
	NAMESERVER3=`echo ${NAMESERVER3T} | sed 's/ *\/.*//'`
	
	NAMESERVER1S="${NAMESERVER1};"
	if [ "${NAMESERVER1}" == "" ]
	then
		NAMESERVER1S=""
	fi 
	NAMESERVER2S="${NAMESERVER2};"
	if [ "${NAMESERVER2}" == "" ]
	then
		NAMESERVER2S=""
	fi
	NAMESERVER3S="${NAMESERVER3};"
	if [ "${NAMESERVER3}" == "" ]
	then
		NAMESERVER3S=""
	fi
	
	# DNS servers
cat > /etc/bind/named.conf.options << EOF
options {
	version "Bind ver";
	directory "/var/cache/bind";
	forward only;
	forwarders {
	$NAMESERVER1S
	$NAMESERVER2S
	$NAMESERVER3S
	};
	auth-nxdomain no;    # conform to RFC1035
	dnssec-enable no;
	dnssec-validation no;

};
EOF
else
	# delete lines from named.conf.options
	if [ "$1" == "primary" ]
	then
		sed -i '5s/.*/ /' /etc/bind/named.conf.options
	fi
	if [ "$1" == "secondary" ]
	then
		sed -i '6s/.*/ /' /etc/bind/named.conf.options
	fi
	if [ "$1" == "tertiary" ]
	then
		sed -i '7s/.*/ /' /etc/bind/named.conf.options
	fi
fi
# end of delete dns (no dns-server)

if [ "$1" == "" ] || [ "$1" == "domain" ] 
then
	# conf domain
	DOMAIN=$(/sbin/cfg-getparams.sh mmSystemConfigDomainName)
	if [ "$1" == "domain" ]
	then
		DOMAIN=$2
	fi

	if [ "$2" != "delete" ]
	then
		cat > /etc/resolv.conf << EOF 
#
# resolv.conf  This file is the resolver configuration file
# See resolver(5).
#
search private-domain ${DOMAIN}

nameserver 127.0.0.1
EOF
	else
		cat > /etc/resolv.conf << EOF 
#
# resolv.conf  This file is the resolver configuration file
# See resolver(5).
#
search private-domain

nameserver 127.0.0.1
EOF
	fi
fi

if [ -f /etc/squid.conf ]
then
	DOMEXIST=`cat /etc/squid.conf | grep "append_domain .${DOMAIN}"`
	if [ "${DOMEXIST}" == "" ]
	then
		cat >> /etc/squid.conf <<EOF
append_domain .${DOMAIN}
EOF
	fi
fi

if [ "$INPUT" != "" ] 
then
	isSystemd=`/sbin/cfg-isSystemdInit.sh`
	if [ "$isSystemd" == "NO" ]
	then
		os_1=`uname -a | grep -i mvl`
		if [ "$os_1" != "" ]
		then
			/etc/init.d/bind9 restart
		else
			if [ -e /etc/init.d/bind ]
			then
				/etc/init.d/bind restart
			else
				echo "Error: startup script for DNS service not found - not restarting"
			fi
		fi
	else
		if [ `systemctl is-enabled named.service 2>/dev/null` == "enabled" ]
		then
			systemctl restart named.service
		else
			echo "Error: systemd target for DNS service not found - not restarting"
		fi
	fi
fi
