#!/bin/bash
# Usage: sbin/cfg-eswVlanConf.sh 
#               vlanCreate <vlan_id [2  4094; without 1006  1008 and 2005]>
#               vlanRemove <vlan_id [2  4094; without 1006  1008 and 2005]>
#               vlanPort <vlan_id [1  4094; without 1006  1008]> <interface_number [0/1 - 0/4, 1/1, 1/2]> [<participation [include | exclude]> | <tagging [tag | untag]>]
#               vlanPortPvidSet <interface_number [0/1 - 0/4, 1/1, 1/2]> <vlan_id [1  4094]>
#               showVlanBrief
#               vlanGet <vlan_id [1  4094]>
#               portVlanGet <interface_number>


#version 2.0

function main {
sed -n '/VLAN CONFIG start/,/VLAN CONFIG end/p' "${rcFile}" > "${tempFile1}";

sed -e '/vlan create /d' -e '/vlan add /d' -e '/pvlan set /d' -e '/vlan remove /d' -e '/#tagged/d' -e '/#untagged/d' "${rcFile}" > "${tempFile2}";

if [ -f ${tempFile3} ]
then 
	rm ${tempFile3};
fi

while read line    
do  	
	echo "$line" >> "${tempFile3}";
	if [[ $line == *"VLAN CONFIG start"* ]]
	then
		echo "vlan remove 1 PBM=ge" >> "${tempFile3}";
	fi
	
	if [[ $line == *"MN VLAN start"* ]]
	then
		if [[ "$2" == "1" ]]
		then
			echo "#tagged" >> "${tempFile3}";
			echo "vlan create "$1 >> "${tempFile3}";
			echo "vlan add "$1" PBM=ge2,ge4-ge7,ge11 UBM=ge2,ge11" >> "${tempFile3}";
			echo "pvlan set ge2,ge11 "$1 >> "${tempFile3}";
		elif [[ "$2" == "2" ]]
		then
			echo "#untagged" >> "${tempFile3}";
			echo "vlan create "$1 >> "${tempFile3}";
			echo "vlan add "$1" PBM=ge2,ge4-ge7,ge11 UBM=ge2,ge4-ge7,ge11" >> "${tempFile3}";
			echo "pvlan set ge2,ge4-ge7,ge11 "$1 >> "${tempFile3}";
		else
			flag=0;
			while read line2  
			do  
				if [[ $line2 == *"MN VLAN end"* ]]
				then
					flag=0;
				fi
				if [ $flag == 1 ]
				then
					echo "$line2" >> "${tempFile3}";
				fi	
				if [[ $line2 == *"MN VLAN start"* ]]
				then
					flag=1;
				fi		
			done < "${tempFile1}"
		fi
	fi
	
	if [[ $line == *"INT VLAN start"* ]]
	then
		if [[ "$2" == "3" ]]
		then
			echo "vlan create "$1 >> "${tempFile3}";
			echo "vlan add "$1" PBM=ge0-ge3 UBM=ge3" >> "${tempFile3}";
			echo "pvlan set ge3 "$1 >> "${tempFile3}";
		else
			flag=0;
			while read line2  
			do  
				if [[ $line2 == *"INT VLAN end"* ]]
				then
					flag=0;
				fi
				if [ $flag == 1 ]
				then
					echo "$line2" >> "${tempFile3}";
				fi	
				if [[ $line2 == *"INT VLAN start"* ]]
				then
					flag=1;
				fi		
			done < "${tempFile1}"
		fi
	fi	
done < "${tempFile2}"

mv ${tempFile3} ${rcFile};

return;
}

function intf_nr {

if [ "$1" == "0/1" ]
then
    ifacenbr="4";
elif [ "$1" == "0/2" ]
then
    ifacenbr="5";
elif [ "$1" == "0/3" ]
then
    ifacenbr="6";
elif [ "$1" == "0/4" ]
then
    ifacenbr="7";
elif [ "$1" == "1/1" ]
then
    ifacenbr="0";
elif [ "$1" == "1/2" ]
then
    ifacenbr="1";
elif [ "$1" == "1/3" ]
then
    ifacenbr="2";
elif [ "$1" == "1/4" ]
then
    ifacenbr="3";
elif [ "$1" == "1/5" ]
then
    ifacenbr="8";
elif [ "$1" == "1/6" ]
then
    ifacenbr="9";
elif [ "$1" == "1/7" ]
then
    ifacenbr="10";
elif [ "$1" == "1/8" ]
then
    ifacenbr="11";
elif [ $1 == "-1" ]
then
    ifacenbr="50";
elif [ $1 == "2/1" ]
then
    ifacenbr="201";
elif [ $1 == "2/2" ]
then
    ifacenbr="202";
elif [ $1 == "2/3" ]
then
    ifacenbr="203";
elif [ $1 == "2/4" ]
then
    ifacenbr="204";
elif [ $1 == "2/5" ]
then
    ifacenbr="205";
elif [ $1 == "2/6" ]
then
    ifacenbr="206";
elif [ $1 == "2/7" ]
then
    ifacenbr="207";
elif [ $1 == "2/8" ]
then
    ifacenbr="208";
elif [ $1 == "2/9" ]
then
    ifacenbr="209";
elif [ $1 == "2/10" ]
then
    ifacenbr="210";
elif [ $1 == "2/11" ]
then
    ifacenbr="211";
elif [ $1 == "2/12" ]
then
    ifacenbr="212";
elif [ $1 == "2/13" ]
then
    ifacenbr="213";
elif [ $1 == "2/14" ]
then
    ifacenbr="214";
elif [ $1 == "2/15" ]
then
    ifacenbr="215";
elif [ $1 == "2/16" ]
then
    ifacenbr="216";
elif [ $1 == "2/17" ]
then
    ifacenbr="217";
elif [ $1 == "2/18" ]
then
    ifacenbr="218";
elif [ $1 == "2/19" ]
then
    ifacenbr="219";
elif [ $1 == "2/20" ]
then
    ifacenbr="220";
else
    echo "Error: Wrong switchport interface - $1"
    exit
fi
    
return $ifacenbr;
}


#PROGRAM START POINT

#temp files locations
tempFile1="/tmp/rcsoc_tmp1";
tempFile2="/tmp/rcsoc_tmp2";
tempFile3="/tmp/rcsoc_tmp3";

#rc.soc file location
rcFile="/rc.soc";

vlanID=0; #not set

if [ "$1" = "vlanCreate" ] || [ "$1" = "-vlanCreate" ]
then
    #Create vlan
    vlanID=$2
    /opt/iskratel/sbin/BCMconfigurator -vlan_create $vlanID
elif [ "$1" = "vlanRemove" ] || [ "$1" = "-vlanRemove" ]
then
    #Destroy vlan
    vlanID=$2
    /opt/iskratel/sbin/BCMconfigurator -vlan_destroy $vlanID
elif [ "$1" = "vlanPort" ] || [ "$1" = "-vlanPort" ]
then
    #Add port to VLAN
    vlanID=$2
    intf_nr $3
    port_nr=$?
    if [ "$4" = "include" ]
    then
        /opt/iskratel/sbin/BCMconfigurator -vlan_port $vlanID $port_nr 1
    elif [ "$4" = "exclude" ]
    then
        /opt/iskratel/sbin/BCMconfigurator -vlan_port $vlanID $port_nr 0
    elif [ "$4" = "tag" ]
    then
        /opt/iskratel/sbin/BCMconfigurator -vlan_port $vlanID $port_nr 2
    elif [ "$4" = "untag" ]
    then
        /opt/iskratel/sbin/BCMconfigurator -vlan_port $vlanID $port_nr 3
    else
        echo "cfg-eswVlanConf.sh: Wrong input parameters for port vlan!";
        exit;
    fi
elif [ "$1" = "vlanPortPvidSet" ] || [ "$1" = "-vlanPortPvidSet" ]
then
    #Set PVID
    intf_nr $2
    port_nr=$?
    vlanID=$3
    /opt/iskratel/sbin/BCMconfigurator -vlan_port_pvid_set  $port_nr $vlanID
elif [ "$1" = "showVlanBrief" ] || [ "$1" = "-showVlanBrief" ]
then
    #Show VLAN brief
    /opt/iskratel/sbin/BCMconfigurator -vlan_show_brief
elif [ "$1" = "vlanGet" ] || [ "$1" = "-vlanGet" ]
then
    #Show VLAN
    vlanID=$2
    /opt/iskratel/sbin/BCMconfigurator -vlan_get $vlanID
elif [ "$1" = "portVlanGet" ] || [ "$1" = "-portVlanGet" ]
then
    #Show port VLAN
    intf_nr $2
    port_nr=$?
    /opt/iskratel/sbin/BCMconfigurator -port_vlan_get $port_nr

elif [ "$2" = "1" ] || [ "$2" = "2" ] || [ "$2" = "3" ]
then
    #Previously in this sh file
    main $1 $2
else
        echo "cfg-eswVlanConf.sh: Wrong input parameters!";
        exit;
fi

exit;
