#!/bin/sh

FILE=/etc/startup-config
FSTAB_CFG=/etc/fstab
FSTAB_DEFAULTS=/etc/default/fstab

test -f ${FSTAB_DEFAULTS} && . ${FSTAB_DEFAULTS}

# Remove all comments before mountpoints
sed -i "s%^#*/%/%" ${FSTAB_CFG}
sed -i "s%^#*UUID%UUID%" ${FSTAB_CFG}

# Use FSTAB_SWAPPING value from FSTAB_DEFAULTS
case ${FSTAB_SWAPPING} in
	true|enable|on)
		# Enable swap partitions
		sed -i "/swap/s/^\#*//" ${FSTAB_CFG}
		;;
	*)
		# Disable swap partitions by default
		sed -i "/swap/s/^/\#/" ${FSTAB_CFG}
		;;
esac

HSB=`cat ${FILE} | awk '/hsb/{p=1} /!/{p=0} p' | grep 'enable'`
if [ "${HSB}" == "" ]
then
	# Disable starting drbd
	find /etc/rc* -type l -name S[0-9][0-9]drbd -exec rm -f {} \;
fi
