#!/bin/sh
#

FILE=/etc/startup-config
NODE_CFG=/upgrade_root/etc/sysconfig/node.cfg

host=$1
node_id=$2
housing=$3
tmp=$4

if [ "$tmp" == "tmp" ]
then
	NODE_CFG=/tmp/node.cfg
fi

if [ "$host" == "localhost" ]
then
	# generate node.cfg file

	node_name=$(/sbin/cfg-getparams.sh mmMnNodeName)
	sysType=$(/sbin/cfg-getparams.sh systemType)
	shelfType=$(/sbin/cfg-getparams.sh mmMnChassisType)
	shelfSize=$(/sbin/cfg-getparams.sh mmMnChassisSize)
	locHost=$(/sbin/cfg-getparams.sh localHostname)
	remHost=$(/sbin/cfg-getparams.sh hsbRemoteHostname)
	geoRemHost_1=`cat ${FILE} | grep  'remote node-id 1 hostname' | awk '{print $5}'`
	geoRemHost_2=`cat ${FILE} | grep  'remote node-id 2 hostname' | awk '{print $5}'`

	echo "#------------------------------" > $NODE_CFG
	echo "# node.cfg - file is generated " >> $NODE_CFG
	echo "#------------------------------" >> $NODE_CFG
	echo "NODE_NAME=$node_name" >> $NODE_CFG
	echo "NODE_ID=$node_id" >> $NODE_CFG
	echo "SYSTEM_TYPE=$sysType" >> $NODE_CFG
	echo "SHELF_TYPE=$shelfType" >> $NODE_CFG
	echo "SHELF_SIZE=$shelfSize" >> $NODE_CFG
	echo "HOUSING=$housing" >> $NODE_CFG
	echo "LOC_HOST=$locHost" >> $NODE_CFG
	echo "REM_HOST=$remHost" >> $NODE_CFG
	echo "GEO_REM_HOST_1=$geoRemHost_1" >> $NODE_CFG
	echo "GEO_REM_HOST_2=$geoRemHost_2" >> $NODE_CFG
	echo "#------------------------------" >> $NODE_CFG
else
	# call script on remote target

	/sbin/ha-exec-cmd --cmd="/sbin/cfg-generate-node-file.sh localhost ${node_id} ${housing} ${tmp}" --host="${host}" --username=root

fi

