#!/bin/sh

FILE_BONDSTATIC=/etc/sysconfig/bonding.static

# dump config to tmp file
konf -- -d > /tmp/running-config

# get basic geo system params
product=`cat /tmp/running-config | grep product | awk '{print $2}'`
hostname=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep -c 'remote hostname'`
#ipadd=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep -c 'ip address mgmt' |  grep -vw 'ip address mgmt float' |  grep -vw 'ip address mgmt geofloat'`
ipadd=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'ip address mgmt' |  grep -vw 'ip address mgmt float' |  grep -vw 'ip address mgmt geofloat' | grep -vw 'ip address mgmt tracking-geofloat' | grep -c 'ip address'`
ipaddremfloat=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'remote ip address mgmt float'`
#ipaddgeofloat=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'ip address mgmt geofloat'`
geomode=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'geo-mode'`
geoswitchover=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'geo-switchover'`
preferedunit=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'preferred-unit'`
if [ -f ${FILE_BONDSTATIC} ]
then
	ipaddint="fixed"
	vlanint="fixed"
else
	ipaddint=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep '  ip address internal'`
	vlanint=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'vlan internal'`
	vlan_intf=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'internal interface'`
fi	

if [ "$hostname" == "" ] || [ "$ipadd" == "" ] || [ "$ipaddremfloat" == "" ] || [ "$ipaddremfloat" == "" ] || [ "$ipaddint" == "" ] || [ "$vlanint" == "" ]; then
	echo

	if [ "$hostname" == "" ]
	then
		echo "Hostnames of remote GEO unit not configured! Please do that first."
	fi

        if [ "$ipadd" == "" ]
        then
                echo "Fixed IP address of remote GEO unit not configured! Please do that first."
        fi

#        if [ "$ipaddgeofloat" == "" ]
#        then
#                echo "IP float address of GEO node not configured! Please do that first."
#        fi

        if [ "$ipaddremfloat" == "" ]
        then
                echo "HSB Float IP address of remote GEO unit not configured! Please do that first."
        fi

        if [ "$ipaddint" == "" ]
        then
                echo "Internal IP addresses of remote GEO unit not configured! Please do that first."
        fi
	
        if [ "$vlanint" == "" ] && [ "$vlan_intf" == "" ]
        then
                echo "Internal vlan or interface remote GEO unit not configured! Please do that first."
        fi
        if [ "$geomode" == "" ]
        then
                echo "geo-mode not configured! Please do that first."
        fi
        if [ "$geoswitchover" == "" ]
        then
                echo "geo-switchover not configured! Please do that first."
        fi
        if [ "$preferedunit" == "" ]
        then
                echo "preferred-unit not configured! Please do that first."
        fi
	echo
else
        echo ok
fi

rm /tmp/running-config

