#!/bin/bash

FILE="/etc/startup-config"
#konf -- -d > ${FILE}

systemType=`/sbin/cfg-getparams.sh systemType`

systemName=`/sbin/cfg-getparams.sh mmMnNodeName`
domainName=`/sbin/cfg-getparams.sh mmSystemConfigDomainName`
timeZone=`/sbin/cfg-getparams.sh mmSystemConfigDomainName`
dnsPrimary=`/sbin/cfg-getparams.sh mmNameServer1`
dnsSecondary=`/sbin/cfg-getparams.sh mmNameServer2`
dnsTertiary=`/sbin/cfg-getparams.sh mmNameServer3`
ntpPrimary=`/sbin/cfg-getparams.sh mmNtpServer1`
ntpSecondary=`/sbin/cfg-getparams.sh mmNtpServer2`
ntpTertiary=`/sbin/cfg-getparams.sh mmNtpServer3`
localHostname=`/sbin/cfg-getparams.sh localHostname`
localMgmtIpAddr=`/sbin/cfg-getparams.sh localMnIpAddress`
timezone=`/sbin/cfg-getparams.sh mmSystemConfigTimezone`

mnNet=`/sbin/cfg-getparams.sh mmMnGatewayNet`
if [ "$mnNet" != "" ]
then
	mnNetMask=`/sbin/cfg-getparams.sh mmMnGatewaySubnetMask`
	mnNetGw=`/sbin/cfg-getparams.sh mmMnGateway`
fi

if [ "$systemType" == "duplicated" ]
then
	mgmtFloatIpAddr=`/sbin/cfg-getparams.sh hsbMnFloatIpAddress`
	remoteHostname=`/sbin/cfg-getparams.sh hsbRemoteHostname`
	remoteMgmtIpAddr=`/sbin/cfg-getparams.sh hsbRemoteMnIpAddress`
fi

returnList="{"

returnList+="\"systemType\":\"$systemType\",\"nodeName\":\"$systemName\",\"domainName\":\"$domainName\",\"localHostname\":\"$localHostname\",\"localMnIpAddr\":\"$localMgmtIpAddr\""
returnList+=",\"dnsPrimary\":\"$dnsPrimary\",\"dnsSecondary\":\"$dnsSecondary\",\"dnsTertiary\":\"$dnsTertiary\",\"ntpPrimary\":\"$ntpPrimary\",\"ntpSecondary\":\"$ntpSecondary\",\"ntpTertiary\":\"$ntpTertiary\""

returnList+=",\"timeZone\":\"$timezone\""

if [ "$mnNet" != "" ]
then
	returnList+=",\"mnNodeNetRoute\":{\"netAddr\":\"$mnNet\",\"netMask\":\"$mnNetMask\",\"netGw\":\"$mnNetGw\"}"
else
	returnList+=",\"mnNodeNetRoute\":\"\""
fi

if [ "$systemType" == "duplicated" ]
then
	returnList+=",\"HSB\":{\"floatMnIpAddr\":\"$mgmtFloatIpAddr\",\"remoteHostname\":\"$remoteHostname\",\"remoteMnIpAddr\":\"$remoteMgmtIpAddr\"}"
else
	returnList+=",\"HSB\":\"\""
fi

returnList+="}"

echo $returnList
