#!/bin/bash

FILE="/etc/startup-config"
#konf -- -d > ${FILE}

#get chassis size
chassis_size=`/sbin/cfg-getparams.sh mmMnChassisSize --rest`

# get interface list based on chassis size
intfsFp=`cat $FILE | grep 'interface switchport fp' | cut -d ' ' -f4 | sort -n -t/ -k2,2`
intfsAll="$intfsFp"
intfsBp=`cat /etc/clish/templates/configure-mode-cmj-bcm2.xml.$chassis_size | grep "interface switchport bp 2" | cut -d ' ' -f5 | cut -d '"' -f1`
intfsAll+=" $intfsBp"

#echo
#echo $intfAll
#echo

returnList="{"

# FP interfaces
returnList+="\"FP\":{"

first=0
for intf in $intfsFp; do
	slot=`echo $intf | cut -d '/' -f1`
	port=`echo $intf | cut -d '/' -f2`

	if [ $slot -eq 0 ]
	then
		panel=fp
	else
		panel=bp
	fi

	if [ $slot -eq 0 ]
	then
		vlans=`cat $FILE | awk "/interface switchport fp \<${slot}\/${port}\>/{p=1} /!/{p=0} p" | grep 'vlan participation include' | cut -d ' ' -f5`
	else
		vlans=`cat $FILE | awk "/interface switchport bp \<${slot}\/${port}\>/{p=1} /!/{p=0} p" | grep 'vlan participation include' | cut -d ' ' -f5`
	fi
	vlan_list=`echo $vlans`

	admin=`cat $FILE | awk "/interface switchport $panel \<${slot}\/${port}\>/{p=1} /!/{p=0} p" | grep 'shutdown'`
	if [ "$admin" != "" ]
	then
		shut=`echo $admin | grep no`
		if [ "$shut" == "" ]
		then
			# intf shutdown
			admin_st=no
		else
			#intf no shutdown
			admin_st=yes
		fi
	else
		#intf no shutdown
		admin_st=yes
	fi

#	auto=`cat ${FILE} | awk "/interface switchport $panel \<${slot}\/${port}\>/{p=1} /!/{p=0} p" | grep 'no auto-negotiate'`
#	if [ "$auto" == "" ]
#	then
#		autoneg=yes
#	else
#		autoneg=no
#	fi
#
#	speed=`cat $FILE | awk "/interface switchport $panel \<${slot}\/${port}\>/{p=1} /!/{p=0} p" | grep 'speed' | cut -d ' ' -f3`
#	duplex=`cat $FILE | awk "/interface switchport $panel \<${slot}\/${port}\>/{p=1} /!/{p=0} p" | grep 'speed' | cut -d ' ' -f5`

	if [ $first -eq 0 ]
	then
#		returnList+="\"$intf\":{\"enabled\":\"$admin_st\",\"auto-negotiation\":\"$autoneg\",\"speed\":\"$speed\",\"duplex\":\"$duplex\",\"vlans\":\"$vlans\"}"
		returnList+="\"$intf\":{\"enabled\":\"$admin_st\",\"vlans\":\"$vlans\"}"
		first=1
	else
		returnList+=",\"$intf\":{\"enabled\":\"$admin_st\",\"vlans\":\"$vlans\"}"
#		returnList+=",\"$intf\":{\"enabled\":\"$admin_st\",\"auto-negotiation\":\"$autoneg\",\"speed\":\"$speed\",\"duplex\":\"$duplex\",\"vlans\":\"$vlans\"}"
	fi
done
# end of FP intrfaces
returnList+="}"

# BP interfaces
returnList+=",\"BP\":{"

first=0
for intf in $intfsBp; do
        slot=`echo $intf | cut -d '/' -f1`
        port=`echo $intf | cut -d '/' -f2`

        if [ $slot -eq 0 ]
        then
                panel=fp
        else
                panel=bp
        fi

        if [ $slot -eq 0 ]
        then
                vlans=`cat $FILE | awk "/interface switchport fp \<${slot}\/${port}\>/{p=1} /!/{p=0} p" | grep 'vlan participation include' | cut -d ' ' -f5`
        else
                vlans=`cat $FILE | awk "/interface switchport bp \<${slot}\/${port}\>/{p=1} /!/{p=0} p" | grep 'vlan participation include' | cut -d ' ' -f5`
        fi
        vlan_list=`echo $vlans`

        admin=`cat $FILE | awk "/interface switchport $panel \<${slot}\/${port}\>/{p=1} /!/{p=0} p" | grep 'shutdown'`
        if [ "$admin" != "" ]
        then
                shut=`echo $admin | grep no`
                if [ "$shut" == "" ]
                then
                        # intf shutdown
                        admin_st=no
                else
                        #intf no shutdown
                        admin_st=yes
                fi
        else
                #intf no shutdown
                admin_st=yes
        fi

#       auto=`cat ${FILE} | awk "/interface switchport $panel \<${slot}\/${port}\>/{p=1} /!/{p=0} p" | grep 'no auto-negotiate'`
#       if [ "$auto" == "" ]
#       then
#               autoneg=yes
#       else
#               autoneg=no
#       fi
#
#       speed=`cat $FILE | awk "/interface switchport $panel \<${slot}\/${port}\>/{p=1} /!/{p=0} p" | grep 'speed' | cut -d ' ' -f3`
#       duplex=`cat $FILE | awk "/interface switchport $panel \<${slot}\/${port}\>/{p=1} /!/{p=0} p" | grep 'speed' | cut -d ' ' -f5`

        if [ $first -eq 0 ]
        then
#               returnList+="\"$intf\":{\"enabled\":\"$admin_st\",\"auto-negotiation\":\"$autoneg\",\"speed\":\"$speed\",\"duplex\":\"$duplex\",\"vlans\":\"$vlans\"}"
                returnList+="\"$intf\":{\"enabled\":\"$admin_st\",\"vlans\":\"$vlans\"}"
                first=1
        else
                returnList+=",\"$intf\":{\"enabled\":\"$admin_st\",\"vlans\":\"$vlans\"}"
#               returnList+=",\"$intf\":{\"enabled\":\"$admin_st\",\"auto-negotiation\":\"$autoneg\",\"speed\":\"$speed\",\"duplex\":\"$duplex\",\"vlans\":\"$vlans\"}"
	fi
done
# end of BP interfaces
returnList+="}"

returnList+="}"

echo $returnList
