#!/bin/sh

FILE=/etc/startup-config
FILE_GHAMCF=/opt/iskratel/etc/ham.d/gham.cf
FILE_GHAMCF_DEF=/opt/iskratel/etc/ham.d/gham.cf.geo
FILE_GHAMCF_DEF_NOGHB=/opt/iskratel/etc/ham.d/gham.cf.geo_noghb
MODE_NOGHB=0

first=$1

if [ "$first" == "reboot" ]
then

	# check geo mode 
        GEO_SWITCHOVER_MODE=$(/sbin/cfg-getparams.sh mmGeoRedundancyMode)

	if [ "$GEO_SWITCHOVER_MODE" == "$MODE_NOGHB" ] 
		then

		# check system type
		SYS_TYPE=$(/sbin/cfg-getparams.sh systemType)

		if [ "$SYS_TYPE" == "geo-dual" ] || [ "$SYS_TYPE" == "geo-single" ]
			then

			# check if geo mode enabled
			IS_GEO_ENABLED=$(/sbin/cfg-getparams.sh mmGeoRedundancyType)

			if [ "$IS_GEO_ENABLED" == "redundant" ]
			then
			        S_NODE=$(/sbin/cfg-getparams.sh mmNodeNumber)
			        UNIT_ID=$(/sbin/cfg-getparams.sh mmUnitNumber)
				GEO_TYPE=$(/sbin/cfg-getparams.sh mmGeoL2L3Type)
		        	LOC_HSB_MN_FLOAT=$(/sbin/cfg-getparams.sh mmMnFloatIpAddress1)

				# check if gham cf exists and if old geo-mode is not equal MODE_NOGHB; if not copy def file
                                old_mode=$MODE_NOGHB
				if [ -f $FILE_GHAMCF ]
				then
					old_mode=`cat $FILE_GHAMCF | grep 'GEO_MODE =' | awk '{print $3}'`
				fi

				if [ ! -f $FILE_GHAMCF ] || [ $old_mode != $MODE_NOGHB ]
				then
					cp $FILE_GHAMCF_DEF_NOGHB $FILE_GHAMCF
					if [ "$?" == "1" ]
						then
						echo "Error gham.cf file does not exsist"
						exit 1
					fi

				fi
			
				if [ -f $FILE_GHAMCF ]
				then
					# get old value
					locip_old=`cat $FILE_GHAMCF | grep 'locip ='`
					sed -i -e "s/$locip_old/locip = $LOC_HSB_MN_FLOAT/g" /$FILE_GHAMCF
		
					# change geo switchover mode
					# get old value
					geo_mode_old=`cat $FILE_GHAMCF | grep 'GEO_MODE ='`
					sed -i -e "s/$geo_mode_old/GEO_MODE = $MODE_NOGHB/g" /$FILE_GHAMCF
	
				fi
			else
				if [ -f $FILE_GHAMCF ]
				then
				rm $FILE_GHAMCF
				fi
			fi
		else
			if [ -f $FILE_GHAMCF ]
			then
			rm $FILE_GHAMCF
			fi
		fi

	else

		# check system type
		SYS_TYPE=$(/sbin/cfg-getparams.sh systemType)

		if [ "$SYS_TYPE" == "geo-dual" ] || [ "$SYS_TYPE" == "geo-single" ]
			then

			# check if geo mode enabled
			IS_GEO_ENABLED=$(/sbin/cfg-getparams.sh mmGeoRedundancyType)

			if [ "$IS_GEO_ENABLED" == "redundant" ]
			then
			        S_NODE=$(/sbin/cfg-getparams.sh mmNodeNumber)
			        UNIT_ID=$(/sbin/cfg-getparams.sh mmUnitNumber)
			        GEO_SWITCHOVER_TIMEOUT=$(/sbin/cfg-getparams.sh mmGeoRedundancySOTimeout)
			        GEO_SWITCHOVER_MODE=$(/sbin/cfg-getparams.sh mmGeoRedundancyMode)
			        PREFERED_UNIT=$(/sbin/cfg-getparams.sh mmPreferedUnitNumber)
				GEO_TYPE=$(/sbin/cfg-getparams.sh mmGeoL2L3Type)

				if [ "$UNIT_ID" == "1" ]
				then
			        	LOC_HSB_MN_FLOAT=$(/sbin/cfg-getparams.sh mmMnFloatIpAddress1)
			        	REM_HSB_MN_FLOAT=$(/sbin/cfg-getparams.sh mmMnFloatIpAddress2)
				else
					LOC_HSB_MN_FLOAT=$(/sbin/cfg-getparams.sh mmMnFloatIpAddress2)
			        	REM_HSB_MN_FLOAT=$(/sbin/cfg-getparams.sh mmMnFloatIpAddress1)
				fi

				MN_GEOFLOAT_IP=$(/sbin/cfg-getparams.sh mmGeoMnFloatIpAddr)


				# check if gham cf exists and if old geo-mode is equal MODE_NOGHB; if not copy def file
                                old_mode=2
				if [ -f $FILE_GHAMCF ]
				then
					old_mode=`cat $FILE_GHAMCF | grep 'GEO_MODE =' | awk '{print $3}'`
				fi

				if [ ! -f $FILE_GHAMCF ] || [ $old_mode == $MODE_NOGHB ]
				then
					cp $FILE_GHAMCF_DEF $FILE_GHAMCF
					if [ "$?" == "1" ]
					then
					echo "Eroor gham.cf file does not exsist"
					exit 1
					fi

					# handle tcp port setting - change ports only on unit 2
					if [ "$UNIT_ID" == "2" ]
					then
						# need to change tcp ports
						loc_port_old=`cat $FILE_GHAMCF | grep 'ghblocport =' | awk '{print $3}'`
						rem_port_old=`cat $FILE_GHAMCF | grep 'ghbremport =' | awk '{print $3}'`
		
						loc_port_str=`cat $FILE_GHAMCF | grep 'ghblocport ='`
						rem_port_str=`cat $FILE_GHAMCF | grep 'ghbremport ='`

						sed -i -e "s/$loc_port_str/ghblocport = $rem_port_old ;local TCP port/g" /$FILE_GHAMCF
						sed -i -e "s/$rem_port_str/ghbremport = $loc_port_old ;remote TCP port/g" /$FILE_GHAMCF	
					fi
				fi
			
				if [ -f $FILE_GHAMCF ]
				then
					# change loc hsb float mn ip address
					# get old value
					locip_old=`cat $FILE_GHAMCF | grep 'locip ='`
					sed -i -e "s/$locip_old/locip = $LOC_HSB_MN_FLOAT/g" /$FILE_GHAMCF
		
					# change rem hsb float mn ip address
					# get old value
					remip_old=`cat $FILE_GHAMCF | grep 'remip ='`
					sed -i -e "s/$remip_old/remip = $REM_HSB_MN_FLOAT/g" /$FILE_GHAMCF
	
					# change geo float mn ip address
					# get old value
					altip1_old=`cat $FILE_GHAMCF | grep 'altip1 ='`
					if [ "$GEO_TYPE" == "L2" ]
					then
						sed -i -e "s/$altip1_old/altip1 = $MN_GEOFLOAT_IP/g" /$FILE_GHAMCF
					else
						sed -i -e "s/$altip1_old/altip1 = /g" /$FILE_GHAMCF
					fi
	
					# change geo switchover mode
					# get old value
					geo_mode_old=`cat $FILE_GHAMCF | grep 'GEO_MODE ='`
					sed -i -e "s/$geo_mode_old/GEO_MODE = $GEO_SWITCHOVER_MODE/g" /$FILE_GHAMCF
	
					# change geo switchover timeout
					# get old value
					geo_timeout_old=`cat $FILE_GHAMCF | grep 'TM_REMOTE_DEAD ='`
	
					# convert minutes to seconds
					let "TM_REM_DEAD=${GEO_SWITCHOVER_TIMEOUT} * 60"
	
					sed -i -e "s/$geo_timeout_old/TM_REMOTE_DEAD = ${TM_REM_DEAD}/g" /$FILE_GHAMCF
	
					# set prefered unit
					# get old value
					prefered_old=`cat $FILE_GHAMCF | grep 'PREFERRED ='`
					if [ "$UNIT_ID" == "$PREFERED_UNIT" ]
					then
						sed -i -e "s/$prefered_old/PREFERRED = TRUE/g" /$FILE_GHAMCF
					else
						sed -i -e "s/$prefered_old/PREFERRED = FALSE/g" /$FILE_GHAMCF
					fi
				fi
			else
				if [ -f $FILE_GHAMCF ]
				then
				rm $FILE_GHAMCF
				fi
			fi
		else
			if [ -f $FILE_GHAMCF ]
			then
			rm $FILE_GHAMCF
			fi
		fi
	fi
fi

if [ -f $FILE_GHAMCF ]
then
	if [ "$first" == "mode" ]
	then
	
		geo_mode=$2
	
		# change geo switchover mode
		# get old value
		geo_mode_old=`cat $FILE_GHAMCF | grep 'GEO_MODE ='`
		sed -i -e "s/$geo_mode_old/GEO_MODE = $geo_mode/g" /$FILE_GHAMCF
	
		# send sighup to gham that conf has been changed
		killall -s SIGHUP gham > /dev/null 2>&1
	fi
	
	if [ "$first" == "timeout" ]
	then
	
		timeout=$2
	
		# change geo switchover timeout
		# get old value
		geo_timeout_old=`cat $FILE_GHAMCF | grep 'TM_REMOTE_DEAD ='`
	
		# convert minutes to seconds
		let "rem_dead=${timeout} * 60"
	
		sed -i -e "s/$geo_timeout_old/TM_REMOTE_DEAD = ${rem_dead}/g" /$FILE_GHAMCF
	
		# send sighup to gham that conf has been changed
		killall -s SIGHUP gham > /dev/null 2>&1
		fi
	
	if [ "$first" == "prefered" ]
		then
	
		prefered=$2
	
		prefered_old=`cat $FILE_GHAMCF | grep 'PREFERRED ='`
		unitID=`konf -- -d | awk '/system unit-id/{p=1} /!/{p=0} p' | awk '{print $3}'`
		if [ "$unitID" == "$prefered" ]
		then
			sed -i -e "s/$prefered_old/PREFERRED = TRUE/g" /$FILE_GHAMCF
		else
			sed -i -e "s/$prefered_old/PREFERRED = FALSE/g" /$FILE_GHAMCF
		fi
	
		# send sighup to gham that conf has been changed
		killall -s SIGHUP gham > /dev/null 2>&1
	fi
fi


