#!/bin/bash
# correct hamsysgen and fault-tolerance in app part

FILE_STARTUP=/etc/startup-config
FILE_BONDSTATIC=/etc/sysconfig/bonding.static
FILE_HAMSYSGENCF=/opt/iskratel/etc/ham.d/hamsysgen.cf
FILE_FAULT_TOLERANCE_TMPL=fault_tolerance.cf.templ
FILE_FAULT_TOLERANCE=fault_tolerance.cf

#main

timeout=$(/sbin/cfg-getparams.sh haFaultTolerance)
product=$(/sbin/cfg-getparams.sh product)
if [ "$timeout" == "" ]
then
	if [ "$product" == "Compact_Call_Server" ]
	then
		timeout=7
	else
		timeout=1
	fi
fi

tm_in_msec=`echo $timeout"000"`

# timeout for app - add 1000 + 200 ms
tm_in_sec_for_app=`echo $timeout"200"`

# modify hamsysgen.cf
oldTolerance=`cat ${FILE_HAMSYSGENCF} | grep FaultTolerance`
sed -i "s/$oldTolerance/FaultTolerance = $tm_in_msec/g" ${FILE_HAMSYSGENCF}

# modify fault-tolerance app files
for file_full_name in `find /opt/si2000/neroot/ -name $FILE_FAULT_TOLERANCE_TMPL`; do
	file_name=`echo $file_full_name | rev | cut -d '/' -f1 | rev`
	file_dir=`echo $file_full_name | rev | cut -d '/' -f2- | rev`

	echo "$file_dir $file_name"

	cp $file_full_name $file_dir/$FILE_FAULT_TOLERANCE

cat > $file_dir/$FILE_FAULT_TOLERANCE <<EOF
$tm_in_sec_for_app
EOF

	cat $file_dir/$FILE_FAULT_TOLERANCE
done

