#!/bin/bash
FILE=/etc/startup-config
INTERFACE=bond0

function hsb1_etchadhacf() {
cat > /etc/ha.d/ha.cf <<EOF
debugfile /var/log/ha-debug
logfile	/var/log/ha-log

keepalive 250ms
deadtime  750ms
warntime  500ms
initdead 5

udpport	694
auto_failback off

ucast $INTERFACE.$INT_VLAN $INT2_IP

node ha-$TARGET_NAME1
node ha-$TARGET_NAME2

realtime on
rtprio 36

EOF
}


function nohsb_etchadhacf() {
cat > /etc/ha.d/ha.cf <<EOF
debugfile /var/log/ha-debug
logfile	/var/log/ha-log
keepalive 1
deadtime 8
warntime 2
initdead 10

udpport	694
ucast lo 127.0.0.1
auto_failback off

node localhost
node $TARGET_NAME1

realtime on
rtprio 36

EOF
}

HSB=`cat ${FILE} | awk '/hsb/{p=1} /!/{p=0} p' | grep 'enable'`
if [ "${HSB}" == "" ]
then
TARGET_NAME1=`cat /etc/hostname`
nohsb_etchadhacf
else
	#TARGET_NAME1=`cat ${FILE} | awk '/hostname/{p=1} /!/{p=0} p' |  grep hostname | grep -vw ' hostname' | grep -v 'hostnameredundant'|  head -n 1 | awk '{print $2}'`
  TARGET_NAME1=$(/sbin/cfg-getparams.sh localHostname)
	#TARGET_NAME2=`cat ${FILE} | awk '/hsb/{p=1} /!/{p=0} p' | grep 'hostname' | awk '{print $2}'`
  TARGET_NAME2=$(/sbin/cfg-getparams.sh hsbRemoteHostname)
	#IP=`cat ${FILE} | awk '/hsb/{p=1} /!/{p=0} p' | grep '  ip address internal' |awk '{print $4}'`
  IP=$(/sbin/cfg-getparams.sh hsbRemIntIpAddress)
	. /sbin/cfg-calculate-network.sh ${IP}
        convert_ip_mask
        INT2_IP=`echo ${IPN}`
        echo $INT2_IP

	INT_VLAN=$(/sbin/cfg-getparams.sh mmInternalVlan)

hsb1_etchadhacf
fi
