#!/bin/bash

FILE_CFG=/etc/startup-config
FILE_BONDSTATIC=/etc/sysconfig/bonding.static

TARGET_NAME1=ha-$(/sbin/cfg-getparams.sh mmMnHostname11)
INTVLAN=$(/sbin/cfg-getparams.sh mmInternalVlan)
MN_FLOAT_IP_MASK=$(/sbin/cfg-getparams.sh hsbMnFloatIpMaskAddress)
INT_FLOAT_IP_MASK=$(/sbin/cfg-getparams.sh hsbIntFloatIpMaskAddress)
HSB=`cat ${FILE_CFG} | awk '/hsb/{p=1} /!/{p=0} p' | grep 'enable'`
CHASSIS=$(/sbin/cfg-getparams.sh mmMnChassisType)
MGMT_VLAN=$(/sbin/cfg-getparams.sh mmMnVlan)
product=$(/sbin/cfg-getparams.sh product)

if [ "$CHASSIS" == "OPENSTACK" ]
then
	if [ "$MN_FLOAT_IP_MASK" != "" ]
	then
		# get interface name based on IP address
		float_ip=`echo $MN_FLOAT_IP_MASK | cut -d '/' -f1`
		INTERFACE=`/sbin/eth_from_ip.py $float_ip`
		#INTERFACE="eth1"
	else
		INTERFACE="eth1"
	fi
else
        INTERFACE="bond0"
fi

#echo
#echo "name "$TARGET_NAME1
#echo "int vlan "$INTVLAN
#echo "mn float "$MN_FLOAT_IP_MASK
#echo "int float "$INT_FLOAT_IP_MASK
#echo

if [ "${HSB}" == "" ]
then
	# for standalone systems
	if [ -f ${FILE_BONDSTATIC} ] && [ "$product" == "Compact_Call_Server" ]
	then
cat > /etc/ha.d/haresources <<EOF
$TARGET_NAME1 haminitra IPaddr2::$INT_FLOAT_IP_MASK/$INTERFACE.2005 rndc bcmFilterReconfig ntpReconfig
EOF
	else
cat > /etc/ha.d/haresources <<EOF
$TARGET_NAME1 haminitra rndc
EOF
	fi		
else
	# for duplicated systems
	if [ "${MN_FLOAT_IP_MASK}" == "" ]
	then
		if [ -f ${FILE_BONDSTATIC} ]
		then
			if [ "$product" == "Compact_Call_Server" ]
			then
cat > /etc/ha.d/haresources <<EOF
$TARGET_NAME1 hamreb haminitra IPaddr2::$INT_FLOAT_IP_MASK/$INTERFACE.2005 rndc bcmFilterReconfig ntpReconfig
EOF
			else # MG
cat > /etc/ha.d/haresources <<EOF
$TARGET_NAME1 hamreb haminitra IPaddr2::$INT_FLOAT_IP_MASK/$INTERFACE.$INTVLAN rndc
EOF
			fi
		else
cat > /etc/ha.d/haresources <<EOF
$TARGET_NAME1 hamreb haminitra rndc
EOF
		fi
	else
		if [ -f ${FILE_BONDSTATIC} ]
		then
			if [ "$product" == "Compact_Call_Server" ]
                        then
				if [ "${MGMT_VLAN}" == "" ]
				then
cat > /etc/ha.d/haresources <<EOF
$TARGET_NAME1 hamreb haminitra IPaddr2::$MN_FLOAT_IP_MASK/$INTERFACE IPaddr2::$INT_FLOAT_IP_MASK/$INTERFACE.2005 rndc bcmFilterReconfig ntpReconfig
EOF
				else
cat > /etc/ha.d/haresources <<EOF
$TARGET_NAME1 hamreb haminitra IPaddr2::$MN_FLOAT_IP_MASK/$INTERFACE.$MGMT_VLAN IPaddr2::$INT_FLOAT_IP_MASK/$INTERFACE.2005 rndc bcmFilterReconfig ntpReconfig
EOF
				fi
			else #MG
				if [ "${MGMT_VLAN}" == "" ]
                                then
cat > /etc/ha.d/haresources <<EOF
$TARGET_NAME1 hamreb haminitra IPaddr2::$MN_FLOAT_IP_MASK/$INTERFACE IPaddr2::$INT_FLOAT_IP_MASK/$INTERFACE.$INTVLAN rndc
EOF
                                else
cat > /etc/ha.d/haresources <<EOF
$TARGET_NAME1 hamreb haminitra IPaddr2::$MN_FLOAT_IP_MASK/$INTERFACE.$MGMT_VLAN IPaddr2::$INT_FLOAT_IP_MASK/$INTERFACE.$INTVLAN rndc
EOF
                                fi
			fi
		else
			if [ "${MGMT_VLAN}" == "" ]
			then
cat > /etc/ha.d/haresources <<EOF
$TARGET_NAME1 IPaddr2::$MN_FLOAT_IP_MASK/$INTERFACE hamreb haminitra rndc
EOF
			else
cat > /etc/ha.d/haresources <<EOF
$TARGET_NAME1 IPaddr2::$MN_FLOAT_IP_MASK/$INTERFACE.$MGMT_VLAN hamreb haminitra rndc
EOF
			fi
		fi
	fi
fi

