#!/bin/sh
FILE_HATACF=/etc/sysconfig/hata.cf
FILE_CFG=/etc/startup-config

#main
HSB=`cat ${FILE_CFG} | awk '/hsb/{p=1} /!/{p=0} p' | grep 'enable'`
if [ "${HSB}" == "" ]
then
HOTSB="FALSE"

#get local MN IP
  #IP=`cat ${FILE_CFG} | awk '/interface mgmt/{p=1} /!/{p=0} p' | grep ' ip address' |awk '{print $3}'`
  IP=$(/sbin/cfg-getparams.sh localMnIpAddress)
. /sbin/cfg-calculate-network.sh ${IP}
convert_ip_mask
LOC_MN=`echo ${IPN}`
echo $LOC_MN
else
HOTSB="TRUE"

#get local MN IP
  #IP=`cat ${FILE_CFG} | awk '/interface mgmt/{p=1} /!/{p=0} p' | grep ' ip address' |awk '{print $3}'`
  IP=$(/sbin/cfg-getparams.sh localMnIpAddress)
. /sbin/cfg-calculate-network.sh ${IP}
convert_ip_mask
LOC_MN=`echo ${IPN}`
echo $LOC_MN

#get remote MN IP
  #IP=`cat ${FILE_CFG} | awk '/hsb/{p=1} /!/{p=0} p' | grep '  ip address mgmt' |awk '{print $4}'`
  IP=$(/sbin/cfg-getparams.sh hsbRemoteMnIpAddress)
. /sbin/cfg-calculate-network.sh ${IP}
convert_ip_mask
REM_MN=`echo ${IPN}`
echo $REM_MN

#get local internal IP
  #IP=`cat ${FILE_CFG} | awk '/hsb/{p=1} /!/{p=0} p' | grep ' ip address internal' |  grep -vw '  ip address internal' |awk '{print $4}'`
  IP=$(/sbin/cfg-getparams.sh localIntIpAddress)
. /sbin/cfg-calculate-network.sh ${IP}
convert_ip_mask
LOC_INT=`echo ${IPN}`
echo $LOC_INT

#get remote internal IP
  #IP=`cat ${FILE_CFG} | awk '/hsb/{p=1} /!/{p=0} p' | grep '  ip address internal' |awk '{print $4}'`
  IP=$(/sbin/cfg-getparams.sh hsbRemIntIpAddress)
. /sbin/cfg-calculate-network.sh ${IP}
convert_ip_mask
REM_INT=`echo ${IPN}`
echo $REM_INT

GEO=`cat ${FILE_CFG} | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'enable'`
if [ "${GEO}" == "" ]
then
	#get MN HSB float IP
	#IP=`cat ${FILE_CFG} | awk '/hsb/{p=1} /!/{p=0} p' | grep ' ip address mgmt float' |awk '{print $5}'`
	IP=$(/sbin/cfg-getparams.sh hsbMnFloatIpAddress)
	. /sbin/cfg-calculate-network.sh ${IP}
	convert_ip_mask
	MN_FLOAT=`echo ${IPN}`
	echo $MN_FLOAT
else
        #get MN GEO float IP
        IP=$(/sbin/cfg-getparams.sh mmGeoMnFloatIpAddr)
        . /sbin/cfg-calculate-network.sh ${IP}
        convert_ip_mask
        MN_FLOAT=`echo ${IPN}`
        echo $MN_FLOAT
fi

fi

# Generate /etc/sysconfig/hata.cf for HATA
cat > ${FILE_HATACF} <<EOF
HSB = ${HOTSB}
locipint = $LOC_INT
remipint = $REM_INT
floatappipmn = $MN_FLOAT
locappipmn = $LOC_MN
remappipmn = $REM_MN
EOF
