#!/bin/sh

FILE_BONDSTATIC=/etc/sysconfig/bonding.static

# dump config to tmp file
konf -- -d > /tmp/running-config

# get basic system params
product=`cat /tmp/running-config | grep product | awk '{print $2}'`
hostname=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep 'hostname'`
ipadd1=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep 'ip address mgmt' |  grep -vw 'ip address mgmt float'`
ipadd2=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep '  ip address mgmt'`

ipaddfloat=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep 'ip address mgmt float'`
if [ -f ${FILE_BONDSTATIC} ]
then
	# MG and cCS
	ipaddint1="fixed"
	ipaddint2="fixed"
        if [ "$product" == "Compact_Call_Server" ]
        then
		vlanint="fixed"
	else
		vlanint=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep 'vlan internal'`
	fi
else
	ipaddint1=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep 'ip address internal' |  grep -vw '  ip address internal'`
	ipaddint2=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep '  ip address internal'`
	vlanint=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep 'vlan internal'`
	
	intiface=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep 'internal interface'`
fi	

if [ "$hostname" == "" ] || [ "$ipadd" == "" ] || [ "$ipaddfloat" == "" ] || [ "$ipaddint1" == "" ] || [ "$ipaddint2" == "" ] || [ "$vlanint" == "" ]; then

	if [ "$hostname" == "" ]
	then
		echo "Error: HSB redundant hostname not configured! Please do that first."
	fi

        if [ "$ipadd1" == "" ]
        then
                echo "Error: IP address of local hsb node not configured! Please do that first."
        fi

        if [ "$ipadd2" == "" ]
        then
                echo "Error: IP address of remote hsb node not configured! Please do that first."
        fi

        if [ "$ipaddfloat" == "" ]
        then
                echo "Error: IP float address of hsb node not configured! Please do that first."
        fi

        if [ "$ipaddint1" == "" ]
        then
               	echo "Error: Internal IP of local hsb node not configured! Please do that first."
        fi

        if [ "$ipaddint2" == "" ]
        then
               	echo "Error: Internal IP of remote hsb node not configured! Please do that first."
        fi
	
	if [ "$intiface" == "" ]
	then
		if [ "$vlanint" == "" ]
        	then
                	echo "Error: Neither internal fp interface nor Internal vlan configured! Please do that first."
        	fi
        fi
fi

rm /tmp/running-config

