#!/bin/sh
FILE_BONDSTATIC=/etc/sysconfig/bonding.static
# dump config to tmp file
konf -- -d > /tmp/running-config

# get basic system params
product=`cat /tmp/running-config | grep product | awk '{print $2}'`
hostname=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep -c 'remote node-id'`
#ipadd=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep -c 'ip address mgmt' |  grep -vw 'ip address mgmt float' |  grep -vw 'ip address mgmt geofloat'`
ipadd=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'ip address mgmt' |  grep -vw 'ip address mgmt float' | grep -vw 'ip address mgmt geofloat' | grep -vw 'ip address mgmt tracking-geofloat' | grep -c 'ip address'`
ipaddremfloat=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'remote ip address mgmt float'`
#ipaddgeofloat=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'ip address mgmt geofloat'`
geomode=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'geo-mode'`
geoswitchover=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'geo-switchover'`
preferedunit=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'preferred-unit'`
if [ -f ${FILE_BONDSTATIC} ]
then
	# MG and cCS
	ipaddint="fixed"
	if [ "$product" == "Compact_Call_Server" ]
	then
		vlanint="fixed"
	else
		vlanint=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'remote vlan internal'`
	fi
else
	ipaddint=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep -c '  ip address internal' `
	vlanint=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'remote vlan internal'`
	vlan_intf=`cat /tmp/running-config | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'remote internal interface'`
fi	

#if [ "$hostname" != "2" ] || [ "$ipadd" != "4" ] || [ "$ipaddremfloat" == "" ] || [ "$ipaddgeofloat" == "" ] || [ "$ipaddint" == "" ] || [ "$geomode" == "" ] || [ "$geoswitchover" == "" ] || [ "$preferedunit" == "" ]; then
if [ "$hostname" != "2" ] || [ "$ipadd" != "2" ] || [ "$ipaddremfloat" == "" ] || [ "$ipaddint" != "2" ] || [ "$geomode" == "" ] || [ "$geoswitchover" == "" ] || [ "$preferedunit" == "" ]; then
        echo nok
else
	if [ "$vlanint" == "" ] && [ "$vlan_intf" == "" ]
	then
        	echo nok
	else
        	echo ok
	fi
fi


