#!/bin/sh
FILE_BONDSTATIC=/etc/sysconfig/bonding.static
# dump config to tmp file
konf -- -d > /tmp/running-config

# get basic system params
product=`cat /tmp/running-config | grep product | awk '{print $2}'`
hostname=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep 'hostname'`
ipadd=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep 'ip address mgmt' |  grep -vw 'ip address mgmt float'`
ipaddfloat=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep 'ip address mgmt float'`
if [ -f ${FILE_BONDSTATIC} ]
then
	# MG and cCS
	ipaddint1="fixed"
	ipaddint2="fixed"
	if [ "$product" == "Compact_Call_Server" ]
        then
		vlanint="fixed"
	else
		vlanint=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep 'vlan internal'`
	fi
else
	ipaddint1=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep 'ip address internal' |  grep -vw '  ip address internal'`
	ipaddint2=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep '  ip address internal'`
	vlanint=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep 'vlan internal'`
	vlan_int_intf=`cat /tmp/running-config | awk '/hsb/{p=1} /!/{p=0} p' | grep 'internal interface'`
fi	

if [ "$hostname" == "" ] || [ "$ipadd" == "" ] || [ "$ipaddfloat" == "" ] || [ "$ipaddint1" == "" ] || [ "$ipaddint2" == "" ] ; then
	echo nok
else
	if [ "$vlanint" == "" ] && [ "$vlan_int_intf" == "" ]
	then
		echo nok
	else
		echo ok
	fi
fi


