#!/bin/bash

CFG_FILE=/etc/startup-config
ITHA_CFG=/etc/ha.d/itha.cf
ITHA_CFG_HSB=/etc/ha.d/itha.cf.hsb
ITHA_CFG_NOHSB=/etc/ha.d/itha.cf.nohsb
ITHA_CFG_DEFAULT=/opt/iskratel/defaults/templates/itha.cf.hsb

# we need to move itha cfg files if we are on WRL OS
#orig:os=`uname -a | grep -i wr`
#os=`grep "DISTRIB_ID" /etc/lsb-release | grep -i wrlinux`
source /etc/lsb-release
os="UNKNOWN"
tmp_os=$(echo $DISTRIB_ID | grep -i wrlinux)
if [ "$tmp_os" != "" ]
then
	os=WRL
fi

tmp_os=$(echo $DISTRIB_ID | grep -i fsl)
if [ "$tmp_os" != "" ]
then
	os=FSL
fi

tmp_os=$(echo $DISTRIB_ID | grep -i poky)
if [ "$tmp_os" != "" ]
then
	os=ITL
fi

if [ "$os" == "WRL" ] || [ "$os" == "FSL" ] || [ "$os" == "ITL" ]
then
  if [ "$1" == "reboot" ]
  then
	# first read node id - we will use it later
	node_id=`cat $CFG_FILE | awk '/system unit-id/{p=1} /!/{p=0} p' | grep 'node-id' | sed "s|.*node-id ||" | cut -c 1`
	chassis=`cat $CFG_FILE | grep 'chassis type' | awk '{print $3}'`

	# read system type
	sys_type=`cat $CFG_FILE | awk '/system type/{p=1} /!/{p=0} p' | sed "s|.*type ||"`
	if [ "$sys_type" != "standalone" ]
	then
		hsb_enable=`cat $CFG_FILE | awk '/hsb/{p=1} /!/{p=0} p' | grep 'enable'`
		geo_enable=`cat $CFG_FILE | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'enable'`

		if [ "$hsb_enable" == "" ] && [ "$geo_enable" == "" ]
		then
			sys_type=standalone
		fi
	fi
  else
        # first read node id - we will use it later
        node_id=`konf -- -d | awk '/system unit-id/{p=1} /!/{p=0} p' | grep 'node-id' | sed "s|.*node-id ||" | cut -c 1`
	chassis=`konf -- -d | grep 'chassis type' | awk '{print $3}'`

        sys_type=$1
  fi

  if [ "$sys_type" == "standalone" ] || [ "$sys_type" == "geo-single" ]
  then
	if [ -f $ITHA_CFG_NOHSB ]
	then
		mv $ITHA_CFG $ITHA_CFG_HSB
		mv $ITHA_CFG_NOHSB $ITHA_CFG
	fi
  else
	if [ -f $ITHA_CFG_HSB ]
        then
		mv $ITHA_CFG $ITHA_CFG_NOHSB
		mv $ITHA_CFG_HSB $ITHA_CFG
	fi
  fi

  # we need to change Priority to FALSE on node 2 if we are dupl or geo system type
  if [ "$sys_type" != "standalone" ] && [ "$node_id" == "2" ]
  then
	if [ -f $ITHA_CFG ]
	then
		prio=`cat $ITHA_CFG | grep 'Priority = TRUE'`
		if [ "$prio" != "" ]
		then
			sed -i -e "s/Priority = TRUE/Priority = FALSE/g" $ITHA_CFG
		fi
	fi
  fi

  # we need to change Priority to TRUE on node 1 if we are dupl or geo system type
  if [ "$sys_type" != "standalone" ] && [ "$node_id" == "1" ]
  then
	if [ -f $ITHA_CFG ]
	then
		prio=`cat $ITHA_CFG | grep 'Priority = FALSE'`
		if [ "$prio" != "" ]
		then
			sed -i -e "s/Priority = FALSE/Priority = TRUE/g" $ITHA_CFG
		fi
	fi
  fi

  #regardless chassis set to value defined in startup-config if exists
  curr_ft=`cat $ITHA_CFG | grep FaultTolerance |cut -d ' ' -f3`
  new_ft=`cat $CFG_FILE | grep 'faulttolerance' | awk '{print $2}'`

  if [ "${new_ft}" != "" ]
  then
  	echo "FaultTolerance parameter is changed to $new_ft for this system"
  elif [ "${chassis}" == "OPENSTACK" ]
  then
	new_ft=5000
  elif [ "${chassis}" == "VIRTUAL" ]
  then
	new_ft=1000
  else
	if [ -f $ITHA_CFG_DEFAULT ]
	then
		new_ft=`cat $ITHA_CFG_DEFAULT | grep FaultTolerance |cut -d ' ' -f3`
	else
		new_ft=500
	fi
  fi

  #change FaultTolerance if nessesary but only after reboot
  if [ "$1" == "reboot" ]
  then
    if [ "${new_ft}" != "${curr_ft}" ]
    then
	if [ -f $ITHA_CFG ]
	then
		sed -i -e "s/FaultTolerance = $curr_ft/FaultTolerance = $new_ft/g" $ITHA_CFG
	fi
    fi
  fi

  PRODUCT=$(cfg-getparams.sh product)
  if [ "x${PRODUCT}" == "xMedia_Gateway" ]
  then
	  if [ "$sys_type" == "duplicated" ]
	  then
		sed '/\[Libs\/lib1\]/q' $ITHA_CFG | grep -v "\[Libs\/lib1\]" > ${ITHA_CFG}_tmp
		cat >> ${ITHA_CFG}_tmp << EOF 
[Libs/lib1]
enabled = TRUE
name = libhbcmhax.so
type = MAIN

[Libs/lib2]
enabled = TRUE
name = libhbcmping2.so
type = ADDITIONAL
addparam = 192.0.2.30

[Libs/lib3]
enabled = FALSE
name = libhbcmhax.so
type = STONITH
EOF
		mv ${ITHA_CFG}_tmp $ITHA_CFG
	fi
  fi
else
  echo "${os} OS - (unsupported)!"
fi

