#!/bin/bash

[ "$1" = "" ] && exit 1
CFG_F=/etc/ha.d/itha.cf

#
# entry in itha.cf (wih line numbers): 
#   25  [Libs/lib4]
#   26  enabled = FALSE
#   27  name = libhbcmping.so
#   28  addparam = IPADDR
#   29  type = ADDITIONAL
#
# get values for "enabled = " and "addparam = "
ENABLED_VAL=$(cat -n $CFG_F|grep -C3 libhbcmping.so|awk -F= '/enable/ {print $2}'|tr -d ' ')
ADDPARAM_VAL=$(cat -n $CFG_F|grep -C3 libhbcmping.so|awk -F= '/addparam/ {print $2}'|tr -d ' ')

#disable test
if [ "$1" = "remove" ]; then 
	[ "$ENABLED_VAL" = "" ] && exit 0 #section not in cfg file, all done 

	#set enabled to FALSE in /etc/ha.d/itha.cf
	ENABLED_LINE=$(cat -n $CFG_F|grep -C3 libhbcmping.so|awk '/enable/ {print $1}')
	ADDPARAM_LINE=$(cat -n $CFG_F|grep -C3 libhbcmping.so|awk '/addparam/ {print $1}')
	sed -i "$ENABLED_LINE s/enabled = .*/enabled = FALSE/; \
	        $ADDPARAM_LINE s/addparam = .*/addparam = IPADDR/" $CFG_F
	exit 0
fi 

# enable test 
if [ "$ENABLED_VAL" = "" -o "$ADDPARAM_VAL" = "" ]; then 
	#section not yet in cfg file, add it
	#get current lib number 
	LIB_N=$(grep '^\[Libs/lib' $CFG_F|tr -d 'Llibs[]/'|sort -n |tail -n1)
	((LIB_N+=1))
	cat <<- EOF >> $CFG_F
	[Libs/lib$LIB_N]
	enabled = TRUE
	name = libhbcmping.so
	addparam = $1
	type = ADDITIONAL				
	
	EOF
	exit 0
fi

if [ "$ENABLED_VAL" = "TRUE" -a "$ADDPARAM_VAL" = "$1" ]; then 
	echo
	echo "Settings already applied, exit"
	echo
	exit 1
else
	#set values in conf. file
	ENABLED_LINE=$(cat -n $CFG_F|grep -C3 libhbcmping.so|awk '/enable/ {print $1}')
	ADDPARAM_LINE=$(cat -n $CFG_F|grep -C3 libhbcmping.so|awk '/addparam/ {print $1}')
	sed -i "$ENABLED_LINE s/enabled = .*/enabled = TRUE/; \
	        $ADDPARAM_LINE s/addparam = .*/addparam = $1/" $CFG_F 
	exit 0 
fi

