#!/bin/bash

FILE_STARTUP=/etc/startup-config

HSB=`cat ${FILE_STARTUP} | awk '/hsb/{p=1} /!/{p=0} p' | grep 'enable'`
if [ "${HSB}" == "" ]
then
PRODUCT_TYPE="nohsb"
else
PRODUCT_TYPE="hsb"
fi

#get remote MN IP
IP=$(/sbin/cfg-getparams.sh hsbRemoteMnIpAddress)
. /sbin/cfg-calculate-network.sh ${IP}
convert_ip_mask
REM_IP=`echo ${IPN}`

echo $REM_IP

function logt_cfg() {
if [ ${PRODUCT_TYPE} == "hsb" ]
then
	IP_HSB_NODE=${REM_IP}
	echo "IP_HSB_NODE is "${IP_HSB_NODE}
else
	IP_HSB_NODE=
	echo "IP_HSB_NODE is empty due to NOHSB configuration !!!"
fi

mkdir -p /opt/iskratel/etc

cat > /opt/iskratel/etc/logt.cfg << EOF
##################################################################
# This file is generated from itRwc.sh script                    #
##################################################################
# Main configuration data
##################################################################
BACKUP_OPTION=RUN               #make backup(RUN) or not(NORUN)
BACKUP_TIMEOUT=200              #time after system initialization when backup is made
TRANSFER_OPTION=RUN             #make transfer to MN(RUN) or not(NORUN)
TRANSFER_TIMEOUT=10             #time after backup when transfer to MN is made

##################################################################
# tar.gz backup files setup                                      #
##################################################################
pot_tar=/var/backup/logt                        # pot do mape za shranjevanje tar.gz datotek - backupov
max_tar_MNtransfer=5                            # maksimalno stevilo tar.gz datotek - backupov na sistemu
redial_period_MNtransfer=600                    # perioda ponavljanja v sekundah ob prekinitvi z MN
write_history=yes                               # pise zgodovino kreiranih tar.gz v /var/lib/misc/logtTar.history
IP_HSB_node=${IP_HSB_NODE}                       # IP ali hostname podvojene - nasprotne strani

##################################################################
# kaj se backupira - v arhiv vkljuci naslednje datoteke ali mape #
##################################################################
[include] # vkljuci brez brisanja:
###################################
/var/log/                               # vsi logi na /var/log
/opt/solid/work1318/*out                # solid baza
/opt/solid/work1318/*ini                # solid baza
/opt/solid/work1318/*cfg                # solid baza
/etc/*conf                              # etc konfiguracijske datoteke
/etc/hostname                           # ime sistema
/etc/hosts                              # mrezna konfiguracija
/etc/fstab                              # particiniranje fs
/etc/default/ntpdate                    # sistemska ura
/etc/sysconfig                          # sistemska konfiguracija
/etc/network/interfaces                 # mrezna konfiguracija
/etc/ha.d/ha.cf                         # ha konfiguracija
/etc/ha.d/haresources                   # ha konfiguracija
/opt/iskratel/etc/ham.d/ham.cf          # ham konfiguracija
##################################
[rminclude] # vkljuci in izbrise:
##################################
/core*                                  # core datoteke na /
/root/core*                             # core datoteke na /root
/opt/iskratel/bin/core*                 # core datoteke na /opt/iskratel/bin
/opt/si2000/neroot/active/bin/core*     # core datoteke na /opt/si2000/neroot/active/bin
EOF
}

# main #

logt_cfg

