#!/bin/sh

CONF_FILE=/etc/startup-config

# check mlinec configuration - get active ports
actPorts=`cat ${CONF_FILE} | awk '/mlinec bp/{p=1} /!/{p=0} p'`

if test "$actPorts" != "";
then
	actPorts=BP
else
	actPorts=`cat ${CONF_FILE} | awk '/mlinec fp/{p=1} /!/{p=0} p' | sed "s|.*fp ||"`
fi

# debug print
#echo
#echo "actPorts: "$actPorts
#echo

if test "$actPorts" != "";
then

# now set active ports in itmlinec.conf file 
/sbin/cfg-mlinec.sh $actPorts reboot

# --- change rc.soc file ----
# first get chassis type
chass_type=`/sbin/cfg-get-chassis-type.sh`

if [ "${actPorts}" == "copper" ]
then
	/sbin/cfg-port-enable.sh 0/3 disable reboot
	/sbin/cfg-port-enable.sh 0/4 disable reboot
	/sbin/cfg-port-enable.sh 0/1 enable reboot
	/sbin/cfg-port-enable.sh 0/2 enable reboot
fi

if [ "${actPorts}" == "optics" ]
then
	/sbin/cfg-port-enable.sh 0/1 disable reboot
	/sbin/cfg-port-enable.sh 0/2 disable reboot
	/sbin/cfg-port-enable.sh 0/3 enable reboot
	/sbin/cfg-port-enable.sh 0/4 enable reboot
fi

if [ "${actPorts}" == "copper" ] || [ "${actPorts}" == "optics" ]
then
	# if we are in MEA, also disable BP ports
	if [ chass_type == "MEA" ]
	then
		/sbin/cfg-port-enable.sh 1/1 disable reboot
		/sbin/cfg-port-enable.sh 1/2 disable reboot
	fi
fi

if [ "${actPorts}" == "BP" ]
then
	/sbin/cfg-port-enable.sh 0/1 disable reboot
	/sbin/cfg-port-enable.sh 0/2 disable reboot
	/sbin/cfg-port-enable.sh 0/3 disable reboot
	/sbin/cfg-port-enable.sh 0/4 disable reboot
	/sbin/cfg-port-enable.sh 1/1 enable reboot
	/sbin/cfg-port-enable.sh 1/2 enable reboot
fi

fi

