#!/bin/bash
# Make changes on BCM, make changes in itmlinec.conf, tell module mlinec for changes.
# Usage: /sbin/cfg-mlinec.sh
#                   <oper_mode [copper | optics | BP]>
#                   chg_link_equip <port_number> <equip>
#                   chg_mlnc_admn_mode <mlnc_mode>
# Example: /sbin/cfg-mlinec.sh optics
# Example 1: /sbin/cfg-mlinec.sh chg_link_equip 6 1
# Example 2: /sbin/cfg-mlinec.sh chg_mlnc_admn_mode 0

#version 2.0
########################################################################
#                                                                      #
#                                                                      #
#               Copyright (c) 2011 Iskratel                            #
#                                                                      #
#                                                                      #
# Name:         cfg-mlinec.sh                                          #
#                                                                      #
# Description:  configures itmlinec.conf file                          #
#                                                                      #
# Date:         Oct 2012                                               #
#                                                                      #
# Author:       Bor Debelak, ITP RD AS1                                #
#               Goran Strok - six equip control, new mlinec            #
#                                                                      #
# Remarks:      /                                                      #
#                                                                      #
########################################################################

#main function
function mainFunction() {

if [ -f ${tempFile} ]
then 
	rm ${tempFile};
fi

for (( m = 0 ; m < ${#device1[@]} ; m++ ))  
do
   echo "mlnc$m-${admnMode[$m]}:${device1[$m]},${device2[$m]},${device3[$m]},${device4[$m]},${device5[$m]},${device6[$m]}|${equip1[$m]},${equip2[$m]},${equip3[$m]},${equip4[$m]},${equip5[$m]},${equip6[$m]}|${operMode[$m]}|" >> ${tempFile};
done
	
mv ${tempFile} ${confFile};
		
#echo "File itmlinec.conf was successfully changed.";

return;
}

# mand - NOT USED
function portControl() {

if [ "$1" = "copper" ] || [ "$1" = "-copper" ]
then
   /sbin/cfg-port-enable.sh 0/3 disable
   /sbin/cfg-port-enable.sh 0/4 disable
   /sbin/cfg-port-enable.sh 0/1 enable
   /sbin/cfg-port-enable.sh 0/2 enable

	echo -e "Active ports:\tFront panel Copper" > /etc/itmlinec.status
elif [ "$1" = "optics" ] || [ "$1" = "-optics" ]
then
   /sbin/cfg-port-enable.sh 0/1 disable
   /sbin/cfg-port-enable.sh 0/2 disable
   /sbin/cfg-port-enable.sh 0/3 enable
   /sbin/cfg-port-enable.sh 0/4 enable

   echo -e "Active ports:\tFront panel Optics" > /etc/itmlinec.status
elif [ "$1" = "BP" ] || [ "$1" = "-BP" ]
then
   /sbin/cfg-port-enable.sh 0/1 disable
   /sbin/cfg-port-enable.sh 0/2 disable
   /sbin/cfg-port-enable.sh 0/3 disable
   /sbin/cfg-port-enable.sh 0/4 disable
   /sbin/cfg-port-enable.sh 1/1 enable
   /sbin/cfg-port-enable.sh 1/2 enable

   echo -e "Active ports:\tBack panel" > /etc/itmlinec.status
else
   echo "Wrong usage of function portControl!";
   exit;
fi

return;
}

#PROGRAM START POINT

#temp file location
tempFile="/tmp/itmlinec_tmp";

#.conf file location
confFile="/etc/itmlinec.conf";

#global variables
i=0;

unset device1; #array for first devices in instance
unset device2; #array for second devices in instance
unset device3; #array for 3th devices in instance
unset device4; #array for 4th devices in instance
unset device5; #array for 5th devices in instance
unset device6; #array for 6th devices in instance
unset equip1; #array for equip for first devices in instance
unset equip2; #array for equip for second devices in instance
unset equip3; #array for equip for 3th devices in instance
unset equip4; #array for equip for 4th devices in instance
unset equip5; #array for equip for 5th devices in instance
unset equip6; #array for equip for 6th devices in instance
unset admnMode; #array for admin mode in instance
unset operMode; #array for working mode in instance

device1[i]="ge0";
device2[i]="ge1";
device3[i]="ge4";
device4[i]="ge5";
device5[i]="ge6";
device6[i]="ge7";

admnMode[i]="1"

if [ "$1" = "copper" ] || [ "$1" = "-copper" ]
then
   # change itmlinec.conf, enable/disable ports, send trigger to mlinec module
        equip1[i]=$(cat /etc/itmlinec.conf | awk '{ print substr( $0, 33, 1 ) }')
        equip2[i]=$(cat /etc/itmlinec.conf | awk '{ print substr( $0, 35, 1 ) }')
   equip3[i]="1";
   equip4[i]="1";
   equip5[i]="0";
   equip6[i]="0";
   operMode[i]="copper";
        
   mainFunction;

   #portControl copper;

   #perform BCM configurator set only if script is called from runtime and not after reboot from 'system-config-clish'
   if  [ "$2" != "" ]
	then
      if [ "$2" != "reboot" ]
		then
         /opt/iskratel/sbin/BCMconfigurator -set_mlnc_change
      fi
   else
      /opt/iskratel/sbin/BCMconfigurator -set_mlnc_change
   fi
          
   exit;
elif [ "$1" = "optics" ] || [ "$1" = "-optics" ]
then
   # change itmlinec.conf, enable/disable ports, send trigger to mlinec module
	equip1[i]=$(cat /etc/itmlinec.conf | awk '{ print substr( $0, 33, 1 ) }')
	equip2[i]=$(cat /etc/itmlinec.conf | awk '{ print substr( $0, 35, 1 ) }')
   equip3[i]="0";
   equip4[i]="0";
   equip5[i]="1";
   equip6[i]="1";
   operMode[i]="optics";

   mainFunction;

   #portControl optics;

   #perform BCM configurator set only if script is called from runtime and not after reboot from 'system-config-clish'
   if  [ "$2" != "" ]
   then
      if [ "$2" != "reboot" ]
      then
         /opt/iskratel/sbin/BCMconfigurator -set_mlnc_change
      fi
   else
      /opt/iskratel/sbin/BCMconfigurator -set_mlnc_change
   fi

   exit;
   
elif [ "$1" = "BP" ] || [ "$1" = "-BP" ]
then
   # change itmlinec.conf, enable/disable ports, send trigger to mlinec module
   equip1[i]="1";
   equip2[i]="1";
   equip3[i]="0";
   equip4[i]="0";
   equip5[i]="0";
   equip6[i]="0";
   operMode[i]="BP";

   mainFunction;

   #portControl BP;

   #perform BCM configurator set only if script is called from runtime and not after reboot from 'system-config-clish'
   if  [ "$2" != "" ]
   then
      if [ "$2" != "reboot" ]
      then
         /opt/iskratel/sbin/BCMconfigurator -set_mlnc_change
      fi
   else
      /opt/iskratel/sbin/BCMconfigurator -set_mlnc_change
   fi

   exit;
   
elif [ "$1" = "chg_link_equip" ] || [ "$1" = "-chg_link_equip" ]
then
   # change equip status in itmlinec.conf, send trigger to mlinec module
   chCnt=0;

   #convert input intf (0/x) to intf_num
   if [ "$2" == "0/1" ]
   then
      ifacenbr="4";
   elif [ "$2" == "0/2" ]
   then
      ifacenbr="5";
   elif [ "$2" == "0/3" ]
   then
      ifacenbr="6";
   elif [ "$2" == "0/4" ]
   then
      ifacenbr="7";
   elif [ "$2" == "1/1" ]
   then
      ifacenbr="0";
   elif [ "$2" == "1/2" ]
   then
      ifacenbr="1";
   else
      echo "wrong intf"
   fi

   # check which port is to changed
   if [ "$ifacenbr" == "0" ]
   then
      chCnt=33;
   elif [ "$ifacenbr" == "1" ]
   then
      chCnt=35;
   elif [ "$ifacenbr" == "4" ]
   then
      chCnt=37;
   elif [ "$ifacenbr" == "5" ]
   then
      chCnt=39;
   elif [ "$ifacenbr" == "6" ]
   then
      chCnt=41;
   elif [ "$ifacenbr" == "7" ]
   then
      chCnt=43;
   fi

   if [ -f ${tempFile} ]
   then
      rm ${tempFile};
   fi
   if [ $3 == "0" ] || [ $3 == "1" ]
   then
      sed 's/./'$3'/'$chCnt'' "${confFile}" > "${tempFile}";
      mv ${tempFile} ${confFile};

      # perform BCM configurator set only if script is called from runtime and not after reboot from 'system-config-clish'
      if  [ "$4" != "" ]
      then
         if [ "$4" != "reboot" ]
         then
            /opt/iskratel/sbin/BCMconfigurator -set_mlnc_change
         fi
      else	
         /opt/iskratel/sbin/BCMconfigurator -set_mlnc_change
      fi
   else
      echo "Wrong chg_link_equip parameters!";
   fi
   exit;
   
elif [ "$1" = "chg_link_equip_2_ports" ] || [ "$1" = "-chg_link_equip_2_ports" ]
then  
   device1[i]="$2";
   equip1[i]="$3";
   device2[i]="$4";
   equip2[i]="$5";
   
   if [ -f ${tempFile} ]
   then 
      rm ${tempFile};
   fi

   for (( m = 0 ; m < ${#device1[@]} ; m++ ))  
   do
      echo "mlnc$m:${device1[$m]},${device2[$m]}|${equip1[$m]},${equip2[$m]}|" >> ${tempFile};			
   done

   mv ${tempFile} ${confFile};

   #echo "File itmlinec.conf was successfully changed.";

   exit;

elif [ "$1" = "chg_link_equip_1_port" ] || [ "$1" = "-chg_link_equip_1_port" ]
then  
   device1[i]="$2";
   equip1[i]="$3";
   
   if [ -f ${tempFile} ]
   then 
      rm ${tempFile};
   fi

   for (( m = 0 ; m < ${#device1[@]} ; m++ ))  
   do
      echo "mlnc$m:${device1[$m]}|${equip1[$m]}|" >> ${tempFile};			
   done

   mv ${tempFile} ${confFile};

   #echo "File itmlinec.conf was successfully changed.";

   exit;
   
elif [ "$1" = "chg_link_equip_port" ] || [ "$1" = "-chg_link_equip_port" ]
then 
      
   inputPorts=$(grep 'mlnc' /etc/itmlinec.conf | awk -F":" '{print $2}' | awk -F"|" '{print $1}');
   #echo "Ports in itmlinec.conf: $inputPorts";
   inputStatus=$(grep 'mlnc' /etc/itmlinec.conf | awk -F":" '{print $2}' | awk -F"|" '{print $2}');
   #echo "Port statuses in itmlinec.conf: $inputStatus";

   #j=1;
   #echo "${inputPorts}" | cut -d',' -f$j
   
   statusArr=(`echo $inputStatus|tr , ' '`);
   portsArr=(`echo $inputPorts|tr , ' '`);
   
   if [ ${#portsArr[*]} != ${#statusArr[*]} ] || [ ${#portsArr[*]} -gt 6 ]
   then
      echo "cfg-mlinec.sh: wrong data in conf file!";
      exit;
   fi
   
   for ((j=0;j<${#portsArr[*]};j++))
   do 
      if [ "${2}" != "" ] && [ "${3}" != "" ] && [ "${portsArr[j]}" == "$2" ] 
      then
         #echo "Port $2 is $j. in the row, changing its equip status to $3"
         statusArr[$j]=${3};
      elif [ "${4}" != "" ] && [ "${5}" != "" ] && [ "${portsArr[j]}" == "${4}" ] 
      then
         statusArr[$j]=${5};
      elif [ "${6}" != "" ] && [ "${7}" != "" ] && [ "${portsArr[j]}" == "${6}" ] 
      then
         statusArr[$j]=${7};
      elif [ "${8}" != "" ] && [ "${9}" != "" ] && [ "${portsArr[j]}" == "${8}" ] 
      then
         statusArr[$j]=${9};
      elif [ "${10}" != "" ] && [ "${11}" != "" ] && [ "${portsArr[j]}" == "${10}" ] 
      then
         statusArr[$j]=${11};
      elif [ "${12}" != "" ] && [ "${13}" != "" ] && [ "${portsArr[j]}" == "${12}" ] 
      then
         statusArr[$j]=${13};
      fi
      #echo portsArr[$j] = ${portsArr[j]};
      #echo statusArr[$j] = ${statusArr[j]}; 
   done

   if [ -f ${tempFile} ]
   then 
      rm ${tempFile};
   fi

   case ${#portsArr[*]} in
      1)
      echo "mlnc0:${portsArr[0]}|${statusArr[0]}|" >> ${tempFile};   
      ;;
      2)
      echo "mlnc0:${portsArr[0]},${portsArr[1]}|${statusArr[0]},${statusArr[1]}|" >> ${tempFile};
      ;;
      3)
      echo "mlnc0:${portsArr[0]},${portsArr[1]},${portsArr[2]}|${statusArr[0]},${statusArr[1]},${statusArr[2]}|" >> ${tempFile};
      ;;
      4)
      echo "mlnc0:${portsArr[0]},${portsArr[1]},${portsArr[2]},${portsArr[3]}|${statusArr[0]},${statusArr[1]},${statusArr[2]},${statusArr[3]}|" >> ${tempFile};
      ;;
      5)
      echo "mlnc0:${portsArr[0]},${portsArr[1]},${portsArr[2]},${portsArr[3]},${portsArr[4]}|${statusArr[0]},${statusArr[1]},${statusArr[2]},${statusArr[3]},${statusArr[4]}|" >> ${tempFile};
      ;;
      6)
      echo "mlnc0:${portsArr[0]},${portsArr[1]},${portsArr[2]},${portsArr[3]},${portsArr[4]},${portsArr[5]}|${statusArr[0]},${statusArr[1]},${statusArr[2]},${statusArr[3]},${statusArr[4]},${statusArr[5]}|" >> ${tempFile};
      ;;
   esac  

   mv ${tempFile} ${confFile};
      
   exit;
   
elif [ "$1" = "chg_mlnc_admn_mode" ] || [ "$1" = "-chg_mlnc_admn_mode" ]
   then
      # change itmlinec.conf, send trigger to mlinec module
      if [ -f ${tempFile} ]
      then
         rm ${tempFile};
      fi
      if [ $2 == "0" ] || [ $2 == "1" ]
      then
         chCnt=7;
      sed 's/./'$2'/'$chCnt'' "${confFile}" > "${tempFile}";
      mv ${tempFile} ${confFile};

      # perform BCM configurator set only if script is called from runtime and not after reboot from 'system-config-clish'
      if  [ "$3" != "" ]
      then
         if [ "$3" != "reboot" ]
         then
            /opt/iskratel/sbin/BCMconfigurator -set_mlnc_change
         fi
      else
         /opt/iskratel/sbin/BCMconfigurator -set_mlnc_change
      fi
   else	
      echo "Wrong chg_mlnc_admn_mode parameters!";
   fi
   exit;
else
   echo "cfg-mlinec.sh: Wrong input parameters!";
   exit;
fi
exit;
