#!/bin/sh
# Modify startup config in order to transffer it to hsb node
# Input parameters are :
# first parameter: hsb or geo
# second parameter: hostname where modified startup-config will be transffered
MODE=$1
REMHOST=$2

NODE2=`cat /etc/startup-config |grep -w ${REMHOST} |awk '{print $3}'`
if [ "$NODE2" == "2" ]
then
        REMREDUND="yes"
fi


prefixFromIp()
{
   #$1 = IP/prefix
   #out = prefix
   [ "$1" = "" ] && return #should not happen, but could block the script 
   grep -w "$1" $FILE_CFG| awk -F/ '{print $2}' 
}

FILE_CFG=/etc/startup-config
FILE_CFG_REM=/etc/startup-config-${REMHOST}

TARGET_NAME1=$(/sbin/cfg-getparams.sh mmMnHostname11)
TARGET_NAME2=$(/sbin/cfg-getparams.sh mmMnHostname12)
TARGET_NAME21=$(/sbin/cfg-getparams.sh mmMnHostname21)
TARGET_NAME22=$(/sbin/cfg-getparams.sh mmMnHostname22)

IpAddress11=$(/sbin/cfg-getparams.sh mmMnIpAddress11)
IpAddress12=$(/sbin/cfg-getparams.sh mmMnIpAddress12)
IpPrefix11=$(prefixFromIp $IpAddress11)
IpPrefix12=$(prefixFromIp $IpAddress12)
InternalIpAddress11=$(/sbin/cfg-getparams.sh mmMnInternalIpAddress11)
InternalIpAddress12=$(/sbin/cfg-getparams.sh mmMnInternalIpAddress12)
InternalIpPrefix11=$(prefixFromIp $InternalIpAddress11)
InternalIpPrefix12=$(prefixFromIp $InternalIpAddress12)

# delete S_NODE in startup-config
sed -e '/S_NODE/d' ${FILE_CFG} > ${FILE_CFG}.tmp
mv ${FILE_CFG}.tmp ${FILE_CFG}

cp ${FILE_CFG} ${FILE_CFG_REM}

if [ "$MODE" == "hsb" ]
then
        sed -i "s/system unit-id 1.*/system unit-id 1 node-id 2/g" ${FILE_CFG_REM}

        sed -i "s/\bhostname $TARGET_NAME1\b/hostname $TARGET_NAME2/g" ${FILE_CFG_REM}
        sed -i "/hsb/,/!/s/\bhostname $TARGET_NAME2\b/hostname $TARGET_NAME1/g" ${FILE_CFG_REM}

        sed -i "s/ip address $IpAddress11\/$IpPrefix11/ip address $IpAddress12\/$IpPrefix12/g" ${FILE_CFG_REM}
        sed -i "s/ip address mgmt $IpAddress12\/$IpPrefix12/ip address mgmt $IpAddress11\/$IpPrefix11/g" ${FILE_CFG_REM}

	sed -i "/hsb/,/!/s/ ip address internal $InternalIpAddress11\/$InternalIpPrefix11/ ip address internal $InternalIpAddress12\/$InternalIpPrefix12/" ${FILE_CFG_REM}
	sed -i "/hsb/,/!/s/  ip address internal $InternalIpAddress12\/$InternalIpPrefix12/  ip address internal $InternalIpAddress11\/$InternalIpPrefix11/" ${FILE_CFG_REM}
fi

# geopredundancy
if [ "$MODE" == "geo" ]
then
	MNInternalVlan=$(/sbin/cfg-getparams.sh mmInternalVlan)
	MNInternalRemoteVlan=$(/sbin/cfg-getparams.sh mmInternalRemoteVlan)
	
	MNMnGateway=$(/sbin/cfg-getparams.sh mmMnGateway)
	MNMnGatewayNet=$(/sbin/cfg-getparams.sh mmMnGatewayNet)
	MNMnGatewaySubnetMask=$(/sbin/cfg-getparams.sh mmMnGatewaySubnetMask)
	
	MNRemoteMnGateway=$(/sbin/cfg-getparams.sh mmRemoteMnGateway)
	MNRemoteMnGatewayNet=$(/sbin/cfg-getparams.sh mmRemoteMnGatewayNet)
	MNRemoteMnGatewaySubnetMask=$(/sbin/cfg-getparams.sh mmRemoteMnGatewaySubnetMask)
	
        UNITID=`/sbin/cfg-getparams.sh mmUnitNumber  |awk '{print $1}'`
        if [ "${UNITID}" == "1" ]
        then
                UNITIDREM="2"
        else
                UNITIDREM="1"
        fi

        REMNODEID=`cat ${FILE_CFG} | awk '/georedundancy/{p=1} /!/{p=0} p' | grep -w ${REMHOST} | awk '{print $3}'`

        if [ "${REMHOST}" == "${TARGET_NAME21}" ]
        then
                REMHOSTREDUND="${TARGET_NAME22}"
        else
                REMHOSTREDUND="${TARGET_NAME21}"
        fi

        IpAddress21=$(/sbin/cfg-getparams.sh mmMnIpAddress21)
        IpAddress22=$(/sbin/cfg-getparams.sh mmMnIpAddress22)
        IpPrefix21=$(prefixFromIp $IpAddress21)
        IpPrefix22=$(prefixFromIp $IpAddress22)
        InternalIpAddress21=$(/sbin/cfg-getparams.sh mmMnInternalIpAddress21)
        InternalIpAddress22=$(/sbin/cfg-getparams.sh mmMnInternalIpAddress22)
        InternalIpPrefix21=$(prefixFromIp $InternalIpAddress21)
        InternalIpPrefix22=$(prefixFromIp $InternalIpAddress22)
        IpAddressMgmtFloat=`cat ${FILE_CFG} | awk '/hsb/{p=1} /!/{p=0} p' |  grep 'ip address mgmt float' | awk '{printf $5}'| sed 's/\/.*//'`
        IpAddrMgmgFloatPrefix=$(prefixFromIp $IpAddressMgmtFloat)
        RemoteIpAddressMgmtFloat=`cat ${FILE_CFG} | awk '/georedundancy/{p=1} /!/{p=0} p' |  grep 'remote ip address mgmt float' | awk '{printf $6}'| sed 's/\/.*//'`
        RemoteIpAddrMgmgFloatPrefix=$(prefixFromIp $RemoteIpAddressMgmtFloat)

	geoType=$(/sbin/cfg-getparams.sh mmGeoL2L3Type)

        sed -i "s/system unit-id ${UNITID}.*/system unit-id ${UNITIDREM} node-id ${REMNODEID}/g" ${FILE_CFG_REM}
        sed -i "s/\bhostname $TARGET_NAME1\b/hostname ${REMHOST}/g" ${FILE_CFG_REM}
        sed -i "/hsb/,/!/s/\bhostname $TARGET_NAME2\b/hostname ${REMHOSTREDUND}/g" ${FILE_CFG_REM}

	if [ "${REMHOST}" == "${TARGET_NAME21}" ]
        then
        sed -i "s/ip address $IpAddress11\/$IpPrefix11/ip address $IpAddress21\/$IpPrefix21/g" ${FILE_CFG_REM}
        sed -i "s/ip address mgmt $IpAddress12\/$IpPrefix12/ip address mgmt $IpAddress22\/$IpPrefix22/g" ${FILE_CFG_REM}
	else
        sed -i "s/ip address $IpAddress11\/$IpPrefix11/ip address $IpAddress22\/$IpPrefix22/g" ${FILE_CFG_REM}
        sed -i "s/ip address mgmt $IpAddress12\/$IpPrefix12/ip address mgmt $IpAddress21\/$IpPrefix21/g" ${FILE_CFG_REM}	
	fi
	
	if [ "${REMHOST}" == "${TARGET_NAME21}" ]
        then	
		sed -i "/hsb/,/!/s/ ip address internal $InternalIpAddress11\/$InternalIpPrefix11/ ip address internal $InternalIpAddress21\/$InternalIpPrefix21/" ${FILE_CFG_REM}
		sed -i "/hsb/,/!/s/  ip address internal $InternalIpAddress12\/$InternalIpPrefix12/  ip address internal $InternalIpAddress22\/$InternalIpPrefix22/" ${FILE_CFG_REM}
	else
		sed -i "/hsb/,/!/s/ ip address internal $InternalIpAddress11\/$InternalIpPrefix11/ ip address internal $InternalIpAddress22\/$InternalIpPrefix22/" ${FILE_CFG_REM}
		sed -i "/hsb/,/!/s/  ip address internal $InternalIpAddress12\/$InternalIpPrefix12/  ip address internal $InternalIpAddress21\/$InternalIpPrefix21/" ${FILE_CFG_REM}
	fi

        if [ "${REMREDUND}" == "yes" ]
        then
                sed -i "/georedundancy/,/!/s/\bhostname ${REMHOSTREDUND}\b/hostname ${TARGET_NAME1}/g" ${FILE_CFG_REM}
                sed -i "/georedundancy/,/!/s/\bhostname ${REMHOST}\b/hostname ${TARGET_NAME2}/g" ${FILE_CFG_REM}
        else
                sed -i "/georedundancy/,/!/s/\bhostname ${REMHOST}\b/hostname ${TARGET_NAME1}/g" ${FILE_CFG_REM}
                sed -i "/georedundancy/,/!/s/\bhostname ${REMHOSTREDUND}\b/hostname ${TARGET_NAME2}/g" ${FILE_CFG_REM}
        fi

	sed -i "/georedundancy/,/!/s/  ip address mgmt $IpAddress21\/$IpPrefix21/  ip address mgmt $IpAddress11\/$IpPrefix11/g" ${FILE_CFG_REM}
	sed -i "/georedundancy/,/!/s/  ip address mgmt $IpAddress22\/$IpPrefix22/  ip address mgmt $IpAddress12\/$IpPrefix12/g" ${FILE_CFG_REM}
	
	if [ "${InternalIpAddress11}" != "${InternalIpAddress21}" ]
	then
	sed  -i "0,/ ip address internal $InternalIpAddress21\//! s/ ip address internal $InternalIpAddress21\/$InternalIpPrefix21/ ip address internal $InternalIpAddress11\/$InternalIpPrefix11/" ${FILE_CFG_REM}
	sed  -i "0,/ ip address internal $InternalIpAddress22\//! s/ ip address internal $InternalIpAddress22\/$InternalIpPrefix22/ ip address internal $InternalIpAddress12\/$InternalIpPrefix12/" ${FILE_CFG_REM}
	else
	sed  -i "s/ ip address internal $InternalIpAddress21\/$InternalIpPrefix21/ ip address internal $InternalIpAddress11\/$InternalIpPrefix11/g" ${FILE_CFG_REM}
	sed  -i "s/ ip address internal $InternalIpAddress22\/$InternalIpPrefix22/ ip address internal $InternalIpAddress12\/$InternalIpPrefix12/g" ${FILE_CFG_REM}
	fi
	
        sed -i "s/ip address mgmt float $IpAddressMgmtFloat\/$IpAddrMgmgFloatPrefix/ip address mgmt float $RemoteIpAddressMgmtFloat\/$RemoteIpAddrMgmgFloatPrefix/g" ${FILE_CFG_REM}
        sed -i "s/remote ip address mgmt float $RemoteIpAddressMgmtFloat\/$RemoteIpAddrMgmgFloatPrefix/remote ip address mgmt float $IpAddressMgmtFloat\/$IpAddrMgmgFloatPrefix/g" ${FILE_CFG_REM}
	
	VLANINTHSB=`cat ${FILE_CFG_REM} | awk '/hsb/{p=1} /!/{p=0} p' | grep 'vlan internal' | awk '{print $3}'`
	VLANINTGEO=`cat ${FILE_CFG_REM} | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'remote vlan internal' | awk '{print $4}'`
	
	if [ "$VLANINTHSB" != "" ] && [ "$VLANINTGEO" != "" ]
	then
		sed -i "/hsb/,/!/s/ vlan internal $VLANINTHSB/ vlan internal $VLANINTGEO/g" ${FILE_CFG_REM}
		sed -i "/georedundancy/,/!/s/ remote vlan internal $VLANINTGEO/ remote vlan internal $VLANINTHSB/g" ${FILE_CFG_REM}
	fi
	
	INTINTFHSB=`cat ${FILE_CFG_REM} | awk '/hsb/{p=1} /!/{p=0} p' | grep 'internal interface' | awk '{print $3}'`
	INTINTFGEO=`cat ${FILE_CFG_REM} | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'remote internal interface' | awk '{print $4}'`

	if [ "$INTINTFHSB" != "" ] && [ "$INTINTFGEO" != "" ]
	then
		sed -i "/hsb/,/!/s/ vlan internal $INTINTFHSB/ vlan internal $INTINTFGEO/g" ${FILE_CFG_REM}
		sed -i "/georedundancy/,/!/s/ remote vlan internal $INTINTFGEO/ remote vlan internal $INTINTFHSB/g" ${FILE_CFG_REM}
	fi

	
	# remote route
	if [ "$geoType" == "L3" ]
	then
		sed -i "s/ip route mgmt $MNMnGatewayNet $MNMnGatewaySubnetMask $MNMnGateway/ip route mgmt $MNRemoteMnGatewayNet $MNRemoteMnGatewaySubnetMask $MNRemoteMnGateway/g" ${FILE_CFG_REM}
		sed -i "s/ remote ip mgmt route $MNRemoteMnGatewayNet $MNRemoteMnGatewaySubnetMask $MNRemoteMnGateway/ remote ip mgmt route $MNMnGatewayNet $MNMnGatewaySubnetMask $MNMnGateway/g" ${FILE_CFG_REM}
		# do not transfer additonal routes on L3 geo (remove 'ip route add ...' commands) 
		sed -i "/ip route add/{N;d;}" ${FILE_CFG_REM}


		# save additonal routes on L3 geo from selected node
		`grep 'ip route add' ${FILE_CFG}.route > ${FILE_CFG}.routetmp`
		while read add_route; do
			if [ "$(grep -w "$add_route" ${FILE_CFG}.routetmp)" = "" ]; then
				: #no add ip routes on other geo node
			else
	                	sed -i "/^ip route mgmt/i $add_route\n!" ${FILE_CFG_REM}
			fi
		done <<< "$(cat ${FILE_CFG}.routetmp)"
		rm -f ${FILE_CFG}.route*
	fi
	
fi
