#!/bin/bash

KLISH_MSG="#PATCHED by KLISH for DHCP mgmt interface mode"
DHCLIENT_EXIT_HOOK=/etc/dhcp/dhclient-exit-hooks
DHCLIENT_CONF=/etc/dhcp/dhclient.conf

case $1 in 
	patch) 
		#patch dhclient conf and exit-hooks files 
		grep -q "$KLISH_MSG" $DHCLIENT_EXIT_HOOK || \
		   sed -i "/SKIP_DEFAULT_GATEWAY=\"yes\"/aSKIP_DEFAULT_GATEWAY=\"no\" $KLISH_MSG" $DHCLIENT_EXIT_HOOK
		#request routers (important for env. where rfc3442 classless routes are not sent (e.g. Amazon cloud))
		#aalso is not a typo, it is command(a)+text(also) !!!
		grep -q "$KLISH_MSG" $DHCLIENT_CONF || \
		   sed -i "/^request .*rfc3442-classless-static-routes/aalso request routers; $KLISH_MSG" $DHCLIENT_CONF
	;;
	unpatch)
		#delete "patched by KLISH" lines in dhclient conf & exit-hook files 
		grep -q "$KLISH_MSG" $DHCLIENT_EXIT_HOOK && sed -i "/$KLISH_MSG/ d" $DHCLIENT_EXIT_HOOK
		grep -q "$KLISH_MSG" $DHCLIENT_CONF      && sed -i "/$KLISH_MSG/ d" $DHCLIENT_CONF
	;;
	status)
		for f in $DHCLIENT_EXIT_HOOK $DHCLIENT_CONF; do
			grep -q "$KLISH_MSG" $f && PATCHED="patched" || PATCHED="unpatched"
			printf "%s:\t%s\n" $f $PATCHED
		done
	;;
	*) 
		echo "Usage: $0 patch|unpatch|status" >&2
		exit 1
esac
exit 0
