#!/bin/bash

tmp_file=/tmp/intf-list.txt
tmp_file_line=/tmp/line.txt

CLISH_CFG_FILE=/etc/startup-config

# init var
foundIntf=0
intf_type=0
intf=0/0
shut=3
ifacenbr=55

# list all interface (fp and bp) in tmp file
cat ${CLISH_CFG_FILE} | awk '/interface switchport fp/{p=1} /!/{p=0} p' >> $tmp_file
cat ${CLISH_CFG_FILE} | awk '/interface switchport bp 1/{p=1} /!/{p=0} p' >> $tmp_file

while read line
do
	if [ "$foundIntf" == "0" ]
	then
		intf_line=`echo $line | grep "interface switchport"`	
		if [ "$intf_line" != "" ]
		then
			foundIntf=1
			echo $line > $tmp_file_line

			intf_type=`cut -d " " -f 3 ${tmp_file_line}`	
			intf=`cut -d " " -f 4 ${tmp_file_line}`
		#else
			#echo "no interface in line - #$line#"
		fi
	else
		shut_line=`echo $line | grep "shutdown"`		
		if [ "$shut_line" != "" ]
		then
			shut=shutdown
		else
			shut_line=`echo $line | grep "exit"`
			if [ "$shut_line" != "" ]
			then
				shut=noshutdown
			fi	
		fi

		if [ "$shut" != "3" ]
		then
                	# call scripts for setting port admin status in rc.soc and itmlinec.conf
			if [ "$shut" == "shutdown" ]
			then
                		/sbin/cfg-mlinec.sh chg_link_equip $intf 0 reboot
				#echo "/sbin/cfg-mlinec.sh chg_link_equip $intf 0 reboot"
			else
				#echo "/sbin/cfg-mlinec.sh chg_link_equip $intf 1 reboot"
				/sbin/cfg-mlinec.sh chg_link_equip $intf 1 reboot
			fi

			#echo "/sbin/cfg-port-enable.sh $intf $shut reboot"
                	/sbin/cfg-port-enable.sh $intf $shut reboot

                	# clear found intf flag
                	foundIntf=0
			shut=3
		fi
	fi
done < "${tmp_file}"

#debug
#echo
#cat $tmp_file
#echo

#delete tmp file
rm $tmp_file
rm $tmp_file_line

