#!/bin/bash
# Script modifies rc.soc file with data of MN vlans and INT vlans

MNVLAN=$1
MNVLANLNNR=`cat /rc.soc |grep -n '#MN VLAN start' |cut -f1 -d":"`

if test "$MNVLAN" -gt "1" ;then
sed -i "`expr ${MNVLANLNNR} + 1 `s/.*/#tagged $MNVLAN/g" /rc.soc

if [ "$2" != "" ]
then
# hsb system - do not set ge0 and ge1 untagged rule
cat > /rcsoctmp <<EOF
#tagged $MNVLAN
vlan create $MNVLAN
vlan add $MNVLAN PBM=ge0-ge2,ge4-ge7,ge11 UBM=ge11
pvlan set ge11 $MNVLAN
EOF
else
cat > /rcsoctmp <<EOF
#tagged $MNVLAN
vlan create $MNVLAN
vlan add $MNVLAN PBM=ge0-ge2,ge4-ge7,ge11 UBM=ge0-ge1,ge11
pvlan set ge0-ge1,ge11 $MNVLAN
EOF
fi

awk 'FNR==NR{ _[++d]=$0;next}
/#MN VLAN start/{
  print
  for(i=1;i<=d;i++){ print _[i] }
  f=1;next
}
/#MN VLAN end/{f=0}!f' /rcsoctmp /rc.soc > temp && mv temp /rc.soc

else

        if test "$MNVLAN" -eq "1" ;then
cat > /rcsoctmp <<EOF
#untagged 1
EOF

awk 'FNR==NR{ _[++d]=$0;next}
/#MN VLAN start/{
  print
  for(i=1;i<=d;i++){ print _[i] }
  f=1;next
}
/#MN VLAN end/{f=0}!f' /rcsoctmp /rc.soc > temp && mv temp /rc.soc
        fi

fi
