#!/bin/bash

FILE_CFG=/etc/startup-config
SOLID_WORK_DIR=work1318
SOLID_INI_FILE=/opt/solid/${SOLID_WORK_DIR}/solid.ini
SOLID_WORK_DIR_1325=/opt/solid/work1325

function nohsb_common_solidini()
{
	grep -v "PingInterval" ${SOLID_INI_FILE} > ${SOLID_INI_FILE}.tmp
	mv ${SOLID_INI_FILE}.tmp ${SOLID_INI_FILE}

	grep -v "PingTimeout" ${SOLID_INI_FILE} > ${SOLID_INI_FILE}.tmp
	mv ${SOLID_INI_FILE}.tmp ${SOLID_INI_FILE}
}

function mod_solidini()
{
if [ -f ${SOLID_INI_FILE} ]
then
	HSB=`cat ${FILE_CFG} | awk '/hsb/{p=1} /!/{p=0} p' | grep 'enable'`
	if [ "${HSB}" == "" ]
	then
		cat ${SOLID_INI_FILE} | sed "/^;HsbEnabled=yes/s//HsbEnabled=yes/" > ${SOLID_INI_FILE}.tmp
		mv ${SOLID_INI_FILE}.tmp ${SOLID_INI_FILE}
		cat ${SOLID_INI_FILE} | sed "/^Connect= tcp /s//;Connect= tcp /" > ${SOLID_INI_FILE}.tmp
		mv ${SOLID_INI_FILE}.tmp ${SOLID_INI_FILE}
		cat ${SOLID_INI_FILE} | sed "/^;SafenessLevel=2safe/s//SafenessLevel=2safe/" > ${SOLID_INI_FILE}.tmp
		mv ${SOLID_INI_FILE}.tmp ${SOLID_INI_FILE}
		nohsb_common_solidini "work1318"
	else
		TARGET_NAME2=$(/sbin/cfg-getparams.sh hsbRemoteHostname)

		#TARGET_NAME2=`cat ${FILE_CFG} | awk '/hsb/{p=1} /!/{p=0} p' | grep 'hostname' | awk '{print $2}'`

		function hsb_common_solidini()
		{
			
			grep -v "PingInterval" ${SOLID_INI_FILE} > ${SOLID_INI_FILE}.tmp
			cat ${SOLID_INI_FILE}.tmp | sed "s/SafenessLevel=2safe/SafenessLevel=2safe\nPingInterval=200/" > ${SOLID_INI_FILE}
		
			grep -v "PingTimeout" ${SOLID_INI_FILE} > ${SOLID_INI_FILE}.tmp
			cat ${SOLID_INI_FILE}.tmp | sed "s/PingInterval=200/PingInterval=200\nPingTimeout=3000/" > ${SOLID_INI_FILE}
		
			rm ${SOLID_INI_FILE}.tmp
		}
		cat ${SOLID_INI_FILE} | sed "/^;HsbEnabled=yes/s//HsbEnabled=yes/" > ${SOLID_INI_FILE}.tmp
		mv ${SOLID_INI_FILE}.tmp ${SOLID_INI_FILE}
		cat ${SOLID_INI_FILE} | sed "/^;Connect= tcp /s//Connect= tcp /" > ${SOLID_INI_FILE}.tmp
		mv ${SOLID_INI_FILE}.tmp ${SOLID_INI_FILE}
		cat ${SOLID_INI_FILE} | sed "/^\(Connect= tcp \) *[^ ][^ ]* *\([0-9][0-9]*\)$/s//\1ha-${TARGET_NAME2} \2/" > ${SOLID_INI_FILE}.tmp
		mv ${SOLID_INI_FILE}.tmp ${SOLID_INI_FILE}
		cat ${SOLID_INI_FILE} | sed "/^;SafenessLevel=2safe/s//SafenessLevel=2safe/" > ${SOLID_INI_FILE}.tmp
		mv ${SOLID_INI_FILE}.tmp ${SOLID_INI_FILE}
		hsb_common_solidini "work1318"
	fi
fi
}
# main

mod_solidini

# if new instance of solid 1325 exsist modify solid.ini on new working directory
if [ -d "${SOLID_WORK_DIR_1325}" ]
then
SOLID_WORK_DIR=work1325
SOLID_INI_FILE=/opt/solid/${SOLID_WORK_DIR}/solid.ini
mod_solidini
fi

