#!/bin/bash
FILE_CFG=/etc/startup-config
SOLID_WORK_DIR=work1318
SOLID_NET_FILE=/opt/solid/${SOLID_WORK_DIR}/solidnet.cfg
SOLID_WORK_DIR_1325=/opt/solid/work1325
PRODUCT_INFO=/etc/sysconfig/info-product
SOLID_NET_TRANS_DEF_FILE=/opt/solid/default.d/solidnesrv/solidnet_trans.conf

function mod_solidnet()
{
if [ -f ${SOLID_NET_FILE} ]
then
	if [ -f ${PRODUCT_INFO} ]
	then
		product=`cat ${PRODUCT_INFO} | grep 'PRODUCT_FAMILY' | cut -d '=' -f2`
	else
		product=unknown
	fi

	HSB=`cat ${FILE_CFG} | awk '/hsb/{p=1} /!/{p=0} p' | grep 'enable'`
	if [ "${HSB}" == "" ]
	then
		cat ${SOLID_NET_FILE} | sed "/\(tcp \) *[^ ][^ ]* *\(1318\"\)$/s//\1drugi_streznik \2/" > ${SOLID_NET_FILE}.tmp
		mv ${SOLID_NET_FILE}.tmp ${SOLID_NET_FILE}

                locHostname=$(/sbin/cfg-getparams.sh localHostname)

                cat ${SOLID_NET_FILE} | sed "s/CREP_TF_CONNECTION_STRING=.*/CREP_TF_CONNECTION_STRING=\"tcp ${locHostname} 1318\"/" > ${SOLID_NET_FILE}.tmp
                mv ${SOLID_NET_FILE}.tmp ${SOLID_NET_FILE}

		if [ "${product}" != "CS" ]
		then
			cat ${SOLID_NET_FILE} | sed "s/export SOLID_DB_PASSWORD=.*$/export SOLID_DB_PASSWORD=itsolid/" > ${SOLID_NET_FILE}.tmp
			mv ${SOLID_NET_FILE}.tmp ${SOLID_NET_FILE}
		fi
	else
		#get remote internal IP
		#IP=`cat ${FILE_CFG} | awk '/hsb/{p=1} /!/{p=0} p' | grep '  ip address internal' |awk '{print $4}'`
		IP=$(/sbin/cfg-getparams.sh hsbRemIntIpAddress)
		. /sbin/cfg-calculate-network.sh ${IP}
		convert_ip_mask
		INT2_IP=`echo ${IPN}`
		echo $INT2_IP

		cat ${SOLID_NET_FILE} | sed "s/NM_SOLID_CONNECTION_STRING=.*/NM_SOLID_CONNECTION_STRING=\"tf -l1 tcp 1318, tcp ${INT2_IP} 1318\"/" > ${SOLID_NET_FILE}.tmp
		mv ${SOLID_NET_FILE}.tmp ${SOLID_NET_FILE}

		locHostname=$(/sbin/cfg-getparams.sh localHostname)
		remHostname=$(/sbin/cfg-getparams.sh hsbRemoteHostname)

		cat ${SOLID_NET_FILE} | sed "s/CREP_TF_CONNECTION_STRING=.*/CREP_TF_CONNECTION_STRING=\"tf -l1 tcp ${locHostname} 1318, tcp ${remHostname} 1318\"/" > ${SOLID_NET_FILE}.tmp
                mv ${SOLID_NET_FILE}.tmp ${SOLID_NET_FILE}

		if [ "${product}" != "CS" ]
                then
			cat ${SOLID_NET_FILE} | sed "s/export SOLID_DB_PASSWORD=.*$/export SOLID_DB_PASSWORD=itsolid/" > ${SOLID_NET_FILE}.tmp
			mv ${SOLID_NET_FILE}.tmp ${SOLID_NET_FILE}
		fi
	fi

        sysType=`cat ${FILE_CFG} | grep 'system type' | awk '{print $3}'`
        GEO=`cat ${FILE_CFG} | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'enable'`
        if [ "${GEO}" != "" ] && [ "${sysType}" == "geo-dual" ]
        then
                #get old line from solidnet.cfg
		old_line=`cat ${SOLID_NET_FILE} | grep 'REFRESH_INTERVAL'`
	        sed -i -e "s/$old_line/export REFRESH_INTERVAL=600/g" ${SOLID_NET_FILE}

		# correct solid net trans def file
		if [ -f ${SOLID_NET_TRANS_DEF_FILE} ]
		then
			#get old line from solidnet_trans.conf
			old_line=`cat ${SOLID_NET_TRANS_DEF_FILE} | grep 'REFRESH_INTERVAL'`
			sed -i -e "s/$old_line/export REFRESH_INTERVAL=600/g" ${SOLID_NET_TRANS_DEF_FILE}
		else
			echo "Warning: ${SOLID_NET_TRANS_DEF_FILE} does not exist - not changing REFRESH_INTERVAL to 600!"
		fi
        fi

fi
}

function mod_solidnet_1325()
{
if [ -f ${SOLID_NET_FILE} ]
then

	HSB=`cat ${FILE_CFG} | awk '/hsb/{p=1} /!/{p=0} p' | grep 'enable'`
	if [ "${HSB}" == "" ]
	then
		cat ${SOLID_NET_FILE} | sed "/\(tcp \) *[^ ][^ ]* *\(1325\"\)$/s//\1drugi_streznik \2/" > ${SOLID_NET_FILE}.tmp
		mv ${SOLID_NET_FILE}.tmp ${SOLID_NET_FILE}
		cat ${SOLID_NET_FILE} | sed "s/export SOLID_DB_PASSWORD=.*$/export SOLID_DB_PASSWORD=itsolid/" > ${SOLID_NET_FILE}.tmp
		mv ${SOLID_NET_FILE}.tmp ${SOLID_NET_FILE}
	else
		#get remote internal IP
		#IP=`cat ${FILE_CFG} | awk '/hsb/{p=1} /!/{p=0} p' | grep '  ip address internal' |awk '{print $4}'`
		IP=$(/sbin/cfg-getparams.sh hsbRemIntIpAddress)
		. /sbin/cfg-calculate-network.sh ${IP}
		convert_ip_mask
		INT2_IP=`echo ${IPN}`
		echo $INT2_IP

		cat ${SOLID_NET_FILE} | sed "s/SOLID_CONNECTION_STRING=.*/SOLID_CONNECTION_STRING=\"tcp 1325\"/" > ${SOLID_NET_FILE}.tmp
		mv ${SOLID_NET_FILE}.tmp ${SOLID_NET_FILE}
		cat ${SOLID_NET_FILE} | sed "s/export SOLID_DB_PASSWORD=.*$/export SOLID_DB_PASSWORD=itsolid/" > ${SOLID_NET_FILE}.tmp
		mv ${SOLID_NET_FILE}.tmp ${SOLID_NET_FILE}
	fi

        sysType=`cat ${FILE_CFG} | grep 'system type' | awk '{print $3}'`
        GEO=`cat ${FILE_CFG} | awk '/georedundancy/{p=1} /!/{p=0} p' | grep 'enable'`
        if [ "${GEO}" != "" ] && [ "${sysType}" == "geo-dual" ]
        then
                #get old line from solidnet.cfg
		old_line=`cat ${SOLID_NET_FILE} | grep 'REFRESH_INTERVAL'`
	        sed -i -e "s/$old_line/export REFRESH_INTERVAL=600/g" ${SOLID_NET_FILE}
        fi

fi
}

# main
mod_solidnet

# if new instance of solid 1325 exsist modify solidnet.cfg on new working directory
if [ -d "${SOLID_WORK_DIR_1325}" ]
then
SOLID_WORK_DIR=work1325
SOLID_NET_FILE=/opt/solid/${SOLID_WORK_DIR}/solidnet.cfg
mod_solidnet_1325
fi
