	#!/bin/sh
	# Script for check if startup-config exsist
	# If no startup-config is available
	# Prompt for basic system parameters input


	function enterGw()
	{
	b="1"
	while [ $b -gt 0 ]
	do
		echo
		echo  Please enter gateway IP address:
		read GW
		if [ "${GW}" != "" ]
		then
			validate_ip ${GW}
			res=$?
				if [ "$res" != "0" ]
				then
				echo "Error in IP syntax, please try again!"
				i="1"
				j="1"
				else
		cat >${FILEGW} << EOF
${GW}
EOF
				i="0"
				j="0"
				h="0"
				b="0"
				fi
				
		fi
	done
	}

	
	function enterhostname()
	{	
		echo
		echo  Please enter hostname:
		read HOSTNAME
		if [ "${HOSTNAME}" != "" ]
		then
		cat >${FILEHOSTNAME} << EOF
${HOSTNAME}
EOF
		i="0"
		fi
	}
	
	function enterIpAddrMask()
	{
	u="1"
	while [ $u -gt 0 ]
	do
	
	echo	
	echo  "Please enter management IP address in form 'a.b.c.d/mask':"
		read IPADDR
	
	if [[ ${IPADDR} == */* ]]
	then
	IP=`echo "$IPADDR" | sed 's/\/.*//'`
	MASK=`echo "$IPADDR" | awk 'match($0,"/"){print substr($0,RSTART+1,4)}'`
	
	
		if [ "${IP}" != "" ]
		then
		# validate IP
		validate_ip ${IP}
		res=$?
			if [ "$res" != "0" ]
			then
			echo "Error in IP syntax, please try again!"
			i="1"
			j="0"
			z="1"
			else
		cat >${FILEIPADDR} << EOF
$IPADDR
EOF
			i="0"
			j="1"
			z="0"
			u="0"
			fi
		fi
		
		if [ "$i" != "1" ] && [ "$j" != "0" ]
		then 
		# validate mask
		#	if  [[ "$MASK" =~ "^[0-9]+$" ]]
			if  [[ $MASK =~ ^-?[0-9]+$ ]]
			then

		if [ "$MASK" -gt "3" ] && [ "$MASK" -lt "33" ]
		then
		i="0"
		else
				echo "Please enter mask from 4 to 32"
				i="1"
				j="0"
				u="1"
				fi
			else
				echo "Not an integer "
		i="1"
		j="0"
		fi
		fi

		
		
	else
	echo "Error in IP syntax, please try again!"
	i="1"
	j="0"
	fi
	done
	}	
	
	function enterRoute()
	{
		loop="1"
	
		while [ $loop -gt 0 ]
	
		do
		loop="0"
		echo
		echo  "Please enter IP route network address or type 'default' for def. route:"
		read ROUTE
			if [ "${ROUTE}" != "default" ] && [ "${ROUTE}" != "0.0.0.0" ]
			then
				validate_ip ${ROUTE}
				res=$?
				if [ "$res" != "0" ]
				then
					echo "Error in IP syntax, please try again!"
					loop="1"
				else
		cat >${FILEROUTE} << EOF
${ROUTE}
EOF
					i="0"
					err="0"
				fi
			else
				ROUTE="0.0.0.0"
				RT="default"
				err="0"
   	             cat >${FILEROUTE} << EOF
0.0.0.0
EOF
			fi
		done
	
		if [ "$err" != "1" ]
		then	
			if [ "${RT}" != "default" ]
			then
				if [ -f ${FILEMASK} ]
				then
					# Input already done but changes should me made		
					MASK=`cat ${FILEMASK}`
					read -p "Last entered IP route network mask: '${MASK}' Keep this value ? (y/n):" -n 1 -r
					
						z="1"
						while [ $z -gt 0 ]
						echo " "
	
						do
			
						if [[ $REPLY =~ ^[Nn]$ ]]
						then
						entermask
						Z="0"
						break
break
						else
					if [[ $REPLY =~ ^[Yy]$ ]]
					then
						echo
						# echo "OK mask IP address is the same"
							z="0"
							break
					else
							z="1"
					fi
					i="0"
						fi
						done
				else
					entermask
				fi			
			else 
                	cat >${FILEMASK} << EOF
0.0.0.0
EOF
                		i="0"
			fi
		else
			i="1"
		fi
	}
	
	
	function entermask()
	{
		echo
		echo  Please enter IP route network mask:
		read MASK
			if [ "${MASK}" != "" ]
			then
			validate_ip ${MASK}
			res=$?
				if [ "$res" != "0" ]
				then
				echo "Error in IP syntax, please try again!"
				i="1"
				else
		cat >${FILEMASK} << EOF
${MASK}
EOF
				i="0"
				fi
			else
			i="0"
			fi

	}
	
	function enterMgmtVlan()
	{
		loop="1"

		while [ $loop -gt 0 ]

		do
			loop="0"
			echo
			echo  "Please enter management VLAN:"
			read MGMTVLAN

				validate_vlan ${MGMTVLAN}
				res=$?
				if [ "$res" != "0" ]
				then
					echo "Invalid management VLAN, please try again!"
					loop="1"
				else
cat >${FILEMGMTVLAN} << EOF
${MGMTVLAN}
EOF
			   fi

		done
	}

	function validate_vlan()
	{
	local  vlan=$1
	local  stat=1
	if [[ $vlan =~ ^[0-9]+$ ]] && [[ "$vlan" -gt 0 ]] && [[ "$vlan" -lt 4096 ]]; then
		stat=$?
	fi
	if [ -f /etc/sysconfig/bonding.static ]
	then
		if [[ "$vlan" == 2005 ]] || [[ "$vlan" == 1006 ]] || [[ "$vlan" == 1007 ]] || [[ "$vlan" == 1008 ]]; then
			stat=1
		fi
	fi
	return $stat
	}


		
	function validate_ip()
	{
	local  ip=$1
	local  stat=1
	nrdot=`echo "$ip" | grep -o "\." | wc -l`
	if [ "$nrdot" == "3" ]
	then
	if [[ $ip =~ ^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$ ]]; then
		OIFS=$IFS
		IFS='.'
		ip=($ip)
		IFS=$OIFS
		[[ ${ip[0]} -le 255 && ${ip[1]} -le 255 \
		&& ${ip[2]} -le 255 && ${ip[3]} -le 255 ]]
		stat=$?
	fi
	return $stat
	else
	return 1
	fi
	}


#############
# main part #
#############

        if [ "$1" != "" ]
        then
                ROOT_DIR=$1
                mkdir -p $ROOT_DIR/etc
                mkdir -p $ROOT_DIR/etc/sysconfig
        else
                ROOT_DIR=""
        fi

        STFILE=$ROOT_DIR/etc/startup-config
        FILEHOSTNAME=$ROOT_DIR/etc/sysconfig/starthostname
        FILEIPADDR=$ROOT_DIR/etc/sysconfig/startIpMask
        FILEROUTE=$ROOT_DIR/etc/sysconfig/startDefRoute
        FILEMASK=$ROOT_DIR/etc/sysconfig/startRouteMask
        FILEGW=$ROOT_DIR/etc/sysconfig/startGw
		FILEMGMTVLAN=$ROOT_DIR/etc/sysconfig/startMgmtVlan
        FIRST_INSTALL_FLAG=$ROOT_DIR/etc/sysconfig/first_install
	RESTART_WIZZARD_FLAG=$ROOT_DIR/etc/sysconfig/restart_wizz

        i="1"

        while [ $i -gt 0 ]

        do
                if [  -f ${FILEHOSTNAME} ]
                then
                        HOSTNAME=`cat ${FILEHOSTNAME}`
                        # Input already done but changes should me made
                        echo
			
			

			z="1"			
			while [ $z -gt 0 ]
			do
			
                        read -p "Last entered hostname: '${HOSTNAME}' Keep this value? (y/n):" -n 1 -r
                        if [[ $REPLY =~ ^[Yy]$ ]]
                        then
                                echo
				z="0"
				i="0"
				break
                        else
			
				if [[ $REPLY =~ ^[Nn]$ ]]
				then
                                enterhostname
				z="0"
				break
				else
				echo " "
				fi
                        fi
			done
	
			
                else
                        enterhostname
                fi
        done

        i="1"
        j="1"
        while [ $i -gt 0 ]

        do
        if [ "$j" == "1" ]
        then
                if [  -f ${FILEIPADDR} ]
                then
                        # Input already done but changes should me made
                        IPADDR=`cat ${FILEIPADDR}`
			
			
			
				
					z="1"
					while [ $z -gt 0 ]
					echo " "
	
					do
			
                        echo
                        read -p "Last entered IP address/mask: '${IPADDR}' Keep this value ? (y/n):" -n 1 -r
                        if [[ $REPLY =~ ^[Yy]$ ]]
                        then
                                echo
						z="0"
						i="0"
						j="0"
                                break
                        else
						if [[ $REPLY =~ ^[Nn]$ ]]
						then
                                enterIpAddrMask
							if [ "$z" == "0" ]
							then
							break
							fi
						else
						echo " "
						fi
                        fi
					done

                else
                        enterIpAddrMask
                fi
        else
                enterIpAddrMask
        fi
        done

        i="1"
        routechose="1"

        while [ $i -gt 0 ]
        do
                echo
                read -p "Do you wish to add route to MN network or default route? (y/n):" -n 1 -r
                if [[ $REPLY =~ ^[Yy]$ ]]
                then
                        if [  -f ${FILEROUTE} ]
                        then
                                # Input already done but changes should me made
                                ROUTE=`cat ${FILEROUTE}`
                                echo
				z="1"
				while [ $z -gt 0 ]
				echo " "
	
				do
				echo " "
                                read -p "Last entered network address for IP route: '${ROUTE}' Keep this value ? (y/n):" -n 1 -r
                                if [[ $REPLY =~ ^[Nn]$ ]]
                                then
                                        enterRoute
				z="0"
				i="0"
				break
				else
					if [[ $REPLY =~ ^[Yy]$ ]]
					then
					z="0"
					i="0"
					break
					else
					z="1"
                                fi
				fi
				done
                        else
                                enterRoute
				z="0"
				i="0"
				break

                        fi
                        routechose="1"
                else
		if [[ $REPLY =~ ^[Nn]$ ]]
		then
                        routechose="0"
                        i="0"
		else
		i="1"
		fi
                fi

        done

        i="1"
	j="1"

        if [ "${routechose}" != "0" ]
        then

                while [ $i -gt 0 ]
	echo " "

                do
	
	if [ "$j" == "1" ]
	then
                        if [  -f ${FILEGW} ]
                        then
                                # Input already done but changes should me made
                                GW=`cat ${FILEGW}`
                                echo
			h="1"
			while [ $h -gt "0" ]
			do
                                read -p "Last entered gateway IP address: '${GW}' Keep this value ? (y/n):" -n 1 -r
                                if [[ $REPLY =~ ^[Yy]$ ]]
                                then
				echo " "
				h="0"
				j="0"
				break
                                else
				if [[ $REPLY =~ ^[Nn]$ ]]
				then
                                        enterGw
					if [ "$h" == "0" ]
					then
break
                                fi
				else
				h="1"				
				fi
			fi
			done
                        else
                                enterGw
                        fi
	else
	break
	fi	
                done
        fi

		i="1"
		mgmtvlanchose="1"

		while [ $i -gt 0 ]
		do
			echo
			read -p "Do you wish to add management VLAN? (y/n):" -n 1 -r
			if [[ $REPLY =~ ^[Yy]$ ]]
			then
				if [  -f ${FILEMGMTVLAN} ]
				then
					# Input already done but changes should me made
					MGMTVLAN=`cat ${FILEMGMTVLAN}`
					echo
					z="1"
					while [ $z -gt 0 ]
					echo " "

					do
					echo " "
					read -p "Last entered management VLAN: '${MGMTVLAN}' Keep this value ? (y/n):" -n 1 -r
					if [[ $REPLY =~ ^[Nn]$ ]]
					then
						enterMgmtVlan
						z="0"
						i="0"
						break
					else
						if [[ $REPLY =~ ^[Yy]$ ]]
						then
							z="0"
							i="0"
							break
						else
							z="1"
							echo " "
							echo "Wrong selection"
						fi
					fi
					done
				else
					enterMgmtVlan
					z="0"
					i="0"
					break
				fi
				mgmtvlanchose="1"
			else
				if [[ $REPLY =~ ^[Nn]$ ]]
				then
					mgmtvlanchose="0"
					i="0"
				else
					i="1"
					echo " "
					echo "Wrong selection"
				fi
			fi

        done
		
	# Confirmation

	echo
	echo "Check configured values and confirm"
	echo "-----------------------------------"

	# Saved data
	HOSTNAME=`cat ${FILEHOSTNAME}`
	IPADDR=`cat ${FILEIPADDR}`

	if [ "${routechose}" == "1" ]
	then

		ROUTE=`cat ${FILEROUTE}`
		MASK=`cat ${FILEMASK}`
		GW=`cat ${FILEGW}`

	fi
	
	if [ "${mgmtvlanchose}" == "1" ]
	then

		MGMTVLAN=`cat ${FILEMGMTVLAN}`

	fi

	echo "Hostname: ${HOSTNAME}"
	echo "IP address: ${IPADDR}"
	if [ "${routechose}" == "1" ]
	then
		echo "IP route: net ${ROUTE} mask ${MASK} gw ${GW}"
echo
	else
		echo "IP route: not configured"
	fi
	
	if [ "${mgmtvlanchose}" == "1" ]
	then

		echo "Management VLAN: ${MGMTVLAN}"
		echo
	else
		echo "Management VLAN: not configured"

	fi
	
i="1"
while [ $i -gt 0 ]
do

	echo
	read -p "Please confirm values (y/n): " -n 1 -r
	echo    # (optional) move to a new line

	if [[ $REPLY =~ ^[Yy]$ ]]
	then
		# save input params in file
		echo "saving values ..."
		i="0"

		if [ "${routechose}" == "1" ]
		then

cat >${STFILE} << EOF
!
hostname ${HOSTNAME}
!
interface mgmt
 ip address ${IPADDR}
!
ip route mgmt ${ROUTE} ${MASK} ${GW}
EOF

		else

cat >${STFILE} << EOF
!
hostname ${HOSTNAME}
!
interface mgmt
 ip address ${IPADDR}
EOF

		fi
		
		if [ "${mgmtvlanchose}" == "1" ]
		then

cat >>${STFILE} << EOF
!
vlan mgmt ${MGMTVLAN}
EOF

		fi

		# create flag file
		touch $FIRST_INSTALL_FLAG
  
		rm ${FILEHOSTNAME} ${FILEIPADDR}
  
		if [ "${routechose}" == "1" ]
		then
			rm ${FILEROUTE} ${FILEMASK} ${FILEGW}
		fi
		
		if [ "${mgmtvlanchose}" == "1" ]
		then

			rm ${FILEMGMTVLAN}

		fi

		exit 0
	else
		if [[ $REPLY =~ ^[Nn]$ ]]
		then
			i="0"
			# Restarting for input new values...
			bash /sbin/clish_wizard_usb.sh $ROOT_DIR
		else
			i="1"
		fi
	fi
done

