#!/bin/bash

echo "`date` [$PPID:$$] $0 $@" >> /var/log/deployment.log
echo "Apply NE(cCS) basic configuration ... START" >> /var/log/deployment.log

#OB_SCRIPTS_DIR=/opt/openbaton/scripts
CONFIG=/opt/si2000/neroot/config.cfg
STARTUP_CONF=startup-config
NE_CONFIG_DONE=/tmp/ne_config_done
CLOUD_INIT_CLISH_CONFIG=/etc/sysconfig/cloud_init_clish_config
HANDLE_SSH_KEYS_SCRIPT=${OB_SCRIPTS_DIR}/handleSshKeys.sh
my_rebuild=""

 
# check if cofnig file exists
if [ -f ${CONFIG} ]
then
	# load file with config data
	source ${CONFIG}
    
	# check if rebuild is present
	if [ ! -z "$rebuild" ]; then
		my_rebuild="no"
		# split csv
		IFS=',' read -ra HOSTNAME_ARRAY <<< "$rebuild"
		for ONE_HOSTNAME in "${HOSTNAME_ARRAY[@]}"; do
			if [ "x$ONE_HOSTNAME" = "x${my_hostname}" ]; then
				my_rebuild="yes"
				break
			fi
		done
	fi

	# if rebuil is yes or not set (first deploy), then apply config
	if [ "$my_rebuild" != "no" ]
	then
		# touch cloud init clish conf file so clish reload conf does not take place
                touch $CLOUD_INIT_CLISH_CONFIG

		# copy startup-config to /etc
		cp ${STARTUP_CONF} /etc/

		# apply startup-config
		echo -n "Applying startup-config ... " >> /var/log/deployment.log
		/sbin/system-config-clish-runtime
		echo "OK" >> /var/log/deployment.log

		touch $NE_CONFIG_DONE
	fi

#	if [ "$my_rebuild" == "yes" ] && [ "${UNIT_ID}" == "1" ] && [ "${ELEMENT_ID}" == "1" ]
#	then
#		#delete float IPs
#		mgmtGeoFloatIp=`/sbin/cfg-getparams.sh mmGeoMnFloatIpAddr`
#		mgmtHsbFloatIpMask=`/sbin/cfg-getparams.sh hsbMnFloatIpAddress`
#		mgmtLocalIp=`/sbin/cfg-getparams.sh localMnIpAddress | cut -d '/' -f1`
#
#		# get dev name
#		devName=`/sbin/eth_from_ip.py ${mgmtLocalIp}`
#
#		if [ "${mgmtGeoFloatIp}" != "" ] && [ "${devName}" != "" ]
#		then
#			/sbin/ip addr del ${mgmtGeoFloatIp}/32 dev ${devName}
#		fi
#
#		if [ "${mgmtHsbFloatIpMask}" != "" ] && [ "${devName}" != "" ]
#                then
#			/sbin/ip addr del ${mgmtHsbFloatIpMask} dev ${devName}
#		fi
#	fi

	# handle SSH keys
	if [ -e ssh_host_rsa_key ] && [ -e id_rsa ]
	then
		# handle SSH keys sent by orchestrator
		publicHostnameLocal=`/sbin/cfg-getparams.sh ClusterPublicHostnames | grep -v remote | sed "s|.* ||"`
		#publicHostnamesRemote=`/sbin/cfg-getparams.sh ClusterPublicHostnames | grep remote | sed "s|.* ||"`
		#privateHostnameLocal=`/sbin/cfg-getparams.sh ClusterPrivateHostnames | grep -v remote | sed "s|.* ||"`
		#privateHostnamesRemote=`/sbin/cfg-getparams.sh ClusterPrivateHostnames | grep remote | sed "s|.* ||"`
		publicIPLocal=`/sbin/cfg-getparams.sh ClusterPublicIPs | grep -v remote | sed "s|.* ||"`
		#publicIPsRemote=`/sbin/cfg-getparams.sh ClusterPublicIPs | grep remote | sed "s|.* ||"`
		#privateIPLocal=`/sbin/cfg-getparams.sh ClusterPrivateIPs | grep -v remote | sed "s|.* ||"`
		#privateIPsRemote=`/sbin/cfg-getparams.sh ClusterPrivateIPs | grep remote | sed "s|.* ||"`

		sysType=$(/sbin/cfg-getparams.sh systemType)
		if [ "${sysType}" != "standalone" ]
		then
			publicHostnamesRemote=`/sbin/cfg-getparams.sh ClusterPublicHostnames | grep remote | sed "s|.* ||"`
			publicIPsRemote=`/sbin/cfg-getparams.sh ClusterPublicIPs | grep remote | sed "s|.* ||"`
			privateHostnameLocal=`/sbin/cfg-getparams.sh ClusterPrivateHostnames | grep -v remote | sed "s|.* ||"`
			privateHostnamesRemote=`/sbin/cfg-getparams.sh ClusterPrivateHostnames | grep remote | sed "s|.* ||"`
			privateIPLocal=`/sbin/cfg-getparams.sh ClusterPrivateIPs | grep -v remote | sed "s|.* ||"`
			privateIPsRemote=`/sbin/cfg-getparams.sh ClusterPrivateIPs | grep remote | sed "s|.* ||"`
		fi

		if [ "${sysType}" == "standalone" ]
                then
			cluster_list=`echo $publicHostnameLocal $publicIPLocal`
		else
			cluster_list=`echo $publicHostnameLocal $publicHostnamesRemote $privateHostnameLocal $privateHostnamesRemote $publicIPLocal $publicIPsRemote $privateIPLocal $privateIPsRemote`
		fi

                if [ -e $HANDLE_SSH_KEYS_SCRIPT ]
                then
			echo -n "Configure server and root user SSH keys ... (rsa, $cluster_list)"
			$HANDLE_SSH_KEYS_SCRIPT "rsa" "$cluster_list"
			echo "OK"
                else
			echo "error: $HANDLE_SSH_KEYS_SCRIPT does not exist!"
                fi

		# only for non-standalone nodes -> reconfigure ssh client config, so only rsa ssh key is used for communication between node elements
		if [ "${sysType}" != "standalone" ]
                then
			for rem_host in ${cluster_list}
			do
				if [ "${rem_host}" != "$publicHostnameLocal" ] && [ "${rem_host}" != "$publicIPLocal" ] && [ "${rem_host}" != "$privateHostnameLocal" ] && [ "${rem_host}" != "$privateIPLocal" ]
				then
					cat >> /etc/ssh/ssh_config <<EOF
Host ${rem_host}
  HostKeyAlgorithms=ssh-rsa
EOF
				fi
			done
		fi
	else
		# sync ssh keys for root user to all elements - only if we are unit 1 and element 1
		unitID=$(/sbin/cfg-getparams.sh mmUnitNumber)
		elementID=$(/sbin/cfg-getparams.sh mmNodeNumber)
		sysType=$(/sbin/cfg-getparams.sh systemType)

		if [ "${unitID}" == "1" ] && [ "${elementID}" == "1" ]
		then
			if [ "${sysType}" == "duplicated" ]
	                then
				# Cleanup keys with old hostname
				/sbin/ha-ssh-keys generate-server-keys --all-ha-members

				# Give other NEs a chance to bring up network
				echo "I am config primary NE. Sync SSH keys with remote NE ..." >> /var/log/deployment.log

				# Get hsb remote hostname
				hsbNE=$(/sbin/cfg-getparams.sh mmMnHostname12)
				hostAlive=1

				if [ "$hostAlive" == "1" ]
				then
					# sync ssh key for root user wait for 25 sec
					#echo "OK" >> /var/log/deployment.log

					# wait for remote element to finish NE config
					echo >> /var/log/deployment.log
		                        echo -n "Wait for remote NE to finish NE config ..." >> /var/log/deployment.log

					sleep 15
#		                        while true
#		                        do
#						ret=`/sbin/ne_check_config_status.exp ${hsbNE} ${NE_CONFIG_DONE} | grep 'No such file or directory'`
#	                                        if [ "$ret" == "" ]
#	                                        then
#	                                                break
#	                                        else
#	                                                echo -n "." >> /var/log/deployment.log
#	                                                sleep 5
#	                                        fi
#		                        done
		                        echo " OK" >> /var/log/deployment.log

					echo -n "Sync ssh keys to ${hsbNE} (root) ... " >> /var/log/deployment.log
					/sbin/ha-ssh-keys sync-server-keys --username=root --host=${hsbNE}
					/sbin/ha-ssh-keys sync-user-keys --username=root --host=${hsbNE}
					echo "OK" >> /var/log/deployment.log

                                        # touch ssh keys synched flag file
                                        /sbin/ha-exec-cmd --cmd="touch /tmp/ssh_keys_synched" --host=$hsbNE --username=root
				else
					echo "Error: Element not available - SSH keys not synced!" >> /var/log/deployment.log
				fi
			fi # duplicated
                else
			if [ "${sysType}" == "duplicated" ]
                        then
                           # wait for SSH kesy to be synched
                           echo >> /var/log/deployment.log
                           echo -n "Wait for primary NE to synch SSH keys ..." >> /var/log/deployment.log

                           while true
                           do
                                ls -l /tmp/ssh_keys_synched
                                if [ "$?" == "0" ]
                                then
                                        break
                                else
                                        echo -n "." >> /var/log/deployment.log
                                        sleep 5
                                fi
                           done
                           echo " OK" >> /var/log/deployment.log
			fi
		fi # unit 1, element 1
	fi

	auth_copied=no
	shadow_copied=no

        if [ "$my_rebuild" == "yes" ]
        then
                remote_pairs=`/sbin/cfg-getparams.sh ClusterPublicHostnames |grep remote | sed "s|.* ||"`

                for vm in ${remote_pairs}; do
                        is_rebuild=`echo $rebuild |grep $vm`
                        if [ "x$is_rebuild" = "x" ]
                        then
                                # vm not rebuilded, get auth_keys file

                                nc ${vm} 22 -z
                                if [ "$?" == "0" ]
                                then
                                        # copy neadmin authorized_keys file
                                        if [ "$auth_copied" == "no" ]
                                        then
                                                scp root@${vm}:/opt/si2000/neroot/.ssh/authorized_keys* /opt/si2000/neroot/.ssh/
                                                if [ "$?" == "0" ]
                                                then
                                                        auth_copied=yes
                                                        echo "Copied authorized_keys file for user neadmin from ${vm}!"
                                                fi
                                        fi

                                        # copy /etc/shadow file
                                        if [ "$shadow_copied" == "no" ]
                                        then
                                                scp root@${vm}:/etc/shadow /etc/shadow_rec
                                                if [ "$?" == "0" ]
                                                then
                                                        shadow_copied=yes
                                                        echo "Copied /etc/shadow file from ${vm}!"
                                                fi
                                        fi

                                        if [ "$auth_copied" == "yes" ] && [ "$shadow_copied" == "yes" ]
                                        then
                                                break
                                        fi
                                fi
                        fi
                done
        fi

	# if rebuil is yes or not set (first deploy), then remove cloud init clish conf file
        if [ "$my_rebuild" != "no" ]
        then
		# remove cloud init clish conf file
		rm $CLOUD_INIT_CLISH_CONFIG
	fi
else
	echo >> /var/log/deployment.log
	echo "config.cfg does not exist. Can not configure system. ABORTING!" >> /var/log/deployment.log
	echo >> /var/log/deployment.log

	echo "Apply NE(cCS) basic configuration ... END" >> /var/log/deployment.log

	exit 1
fi

#log "NE basic configuration done!"
echo "Apply NE(cCS) basic configuration ... END" >> /var/log/deployment.log

exit 0
