#!/bin/bash

CONFIG="/opt/si2000/neroot/config.cfg"
FUNCTIONS="/etc/ha.d/ha-functions"

echo "#################################################" >> /var/log/deployment.log
echo "# `date` [$PPID:$$] $0 $@" >> /var/log/deployment.log
echo "# cCS NE deploy ... START" >> /var/log/deployment.log
echo "#################################################" >> /var/log/deployment.log
echo "" >> /var/log/deployment.log

if [ -f ${CONFIG} ]
then
	source ${CONFIG}
else
	echo "Missing config.cfg - aborting!" >> /var/log/deployment.log
	echo "cCS NE deploy ... END" >> /var/log/deployment.log
	exit 1
fi

if [ -f ${FUNCTIONS} ]
then
	source ${FUNCTIONS}
else
	echo "Missing support function - not able to log deployment job progress!" >> /var/log/deployment.log
fi


install_job_progress_update "Preparing NE configuration file - startup-config"
sudo /sbin/ne_prepare_startup_config.sh

install_job_progress_update "Applying NE configuration"
sudo /sbin/ne_config.sh

install_job_progress_update "SW Installation and Activation"
sudo /sbin/ne_install_activate.sh

echo "" >> /var/log/deployment.log
echo "##########################" >> /var/log/deployment.log
echo "# cCS NE deploy ... END" >> /var/log/deployment.log
echo "##########################" >> /var/log/deployment.log
echo "" >> /var/log/deployment.log

exit 0
