#!/bin/bash

#echo "`date` [$PPID:$$] $0 $@" >> /var/log/deployment.log
#echo "SW package upgrade and activation ... START" >> /var/log/deployment.log

echo "" >> /var/log/deployment.log
echo "#################################################" >> /var/log/deployment.log
echo "# `date` [$PPID:$$] $0 $@" >> /var/log/deployment.log
echo "# cCS SW package upgrade ... START" >> /var/log/deployment.log
echo "#################################################" >> /var/log/deployment.log
echo "" >> /var/log/deployment.log

CONFIG=/opt/si2000/neroot/config.cfg
UPGRADE_CONFIG=/opt/si2000/neroot/upgrade.cfg
#UPGRADE_CONFIG_CURR=/opt/si2000/neroot/upgrade_curr.cfg
STARTUP_CONF=/etc/startup-config
SW_INSTALL_COMPLETE=/tmp/upgrade-sw-complete
DB_SYNC_COMPLETE=/tmp/upgrade-db-sync-complete
#FIRST_DEPLOY=/upgrade_root/etc/sysconfig/first_deploy

# check if cofnig file exists
if [ -f ${CONFIG} ] && [ -f ${UPGRADE_CONFIG} ]
then
	# load file with config data
	source ${CONFIG}
	source ${UPGRADE_CONFIG}

		# Start SW package installation
		#
		# NOTE: This script has large output so we need to fitler it otherwise
		# ems can crash due to RabbitMQ errror.
		echo "Started NE package installation..." >> /var/log/deployment.log
		echo "Please check /var/log/upgrade-system.log for progress and details." >> /var/log/deployment.log

		MN_NAME=`echo ${MN_FQDN_NAME} | cut -d '.' -f1`
		SW_REPO_URL_ADDR="ftp://${MN_NAME}/${NEW_NE_RELEASE}"

#		if [ "${USE_HTTPS}" == "no" ]
#		then
#			SW_REPO_URL_ADDR="ftp://${MN_NAME}/${NE_RELEASE}"
#		else
#			SW_REPO_URL_ADDR="https://${MN_FQDN_NAME}/mns/ne/${NE_RELEASE}"
#		fi

		echo "" >> /var/log/deployment.log
		echo "/sbin/element-admin.sh --install --use-api-version=1 --repo-sw-url=${SW_REPO_URL_ADDR} --nodeid=${NODE_ID} --datarelease=${NEW_DATA_RELEASE} --housing=${HOUSING}" >> /var/log/deployment.log
		echo "" >> /var/log/deployment.log

                sudo /sbin/element-admin.sh --install --use-api-version=1 --repo-sw-url="${SW_REPO_URL_ADDR}" --nodeid="${NODE_ID}" --datarelease="${NEW_DATA_RELEASE}" --housing="${HOUSING}" &> /dev/null

		if [ "$?" != "0" ]
		then
			echo "Error while installing NE SW package!" >> /var/log/deployment.log

			echo "SW package installation failed ... aborting!" >> /var/log/deployment.log

			exit 1
		fi

		echo "NE SW package installation completed." >> /var/log/deployment.log

		touch $SW_INSTALL_COMPLETE

		# copy config.cfg and upgrade.cfg to newly installed partition
		cp $CONFIG /upgrade_root/$CONFIG
		chown neadmin:users /upgrade_root/$CONFIG
		chmod 755 /upgrade_root/$CONFIG

		#cp $UPGRADE_CONFIG /upgrade_root/$UPGRADE_CONFIG_CURR
		#chown neadmin:users /upgrade_root/$UPGRADE_CONFIG_CURR
		#chmod 755 /upgrade_root/$UPGRADE_CONFIG_CURR

		#cp /etc/init.d/ne_first_deploy.sh /upgrade_root/etc/init.d/
		#ln -s ../init.d/ne_first_deploy.sh /upgrade_root/etc/rc.d/rc3.d/S99ne_first_deploy

		#copy recovered shadow file to upgrade partition(installed package) - in case of VM recovery
#		if [ -f /etc/shadow_rec ]
#		then
#			echo "Copied recovered shadow file to upgrade partition!"
#			cp /etc/shadow_rec /upgrade_root/etc/shadow
#		fi

		# copy ssh client config to upgrade_root
		# this should/will be handeld in installation scripts
	#	cp /etc/ssh/ssh_config /upgrade_root/etc/ssh/ssh_config

	# Execute OpenMN methods only from active node
	unitID=$(/sbin/cfg-getparams.sh mmUnitNumber)
	elementID=$(/sbin/cfg-getparams.sh mmNodeNumber)
	sysType=$(/sbin/cfg-getparams.sh systemType)
	thisNE=$(/sbin/cfg-getparams.sh localHostname)
	hsbNE=$(/sbin/cfg-getparams.sh hsbRemoteHostname)

	unit_busy=`/opt/iskratel/bin/sitool --mwd | grep "Unit State:" | grep "BUSY"`
        local_act=`/opt/iskratel/bin/sitool --mwd | grep "Local Element State:" | grep "ACTIVE"`
        remote_stb=`/opt/iskratel/bin/sitool --mwd | grep "Remote Element State:" | grep "STANDBY"`
        if [ "$unit_busy" != "" ] &&
           [ "$local_act" != "" ] &&
           [ "$remote_stb" != "" ]
        then

		if [ "${sysType}" == "duplicated" ]
		then
			# wait for all elements to finish sw install
			echo "" >> /var/log/deployment.log
			echo -n "Wait for remote NE to finish SW install ..." >> /var/log/deployment.log

			while true
			do
					ne_12=`/sbin/ha-exec-cmd --cmd="ls -l $SW_INSTALL_COMPLETE" --host=$hsbNE --username=root`
					if [ "$ne_12" != "" ]
					then
						break
					else
						echo -n "." >> /var/log/deployment.log
						sleep 5
					fi
			done

			echo " OK" >> /var/log/deployment.log
		fi

		#check if minor or major DB upgrade
		new_db_release=`echo $NEW_DB_RELEASE | cut -c1-6`
		db_release=`echo $DB_RELEASE | cut -c1-6`

		if [ "$new_db_release" != "$db_release" ]
		then
			#major DB upgrade

			# Set node in use
			echo "Setting node IN USE ... " >> /var/log/deployment.log
			if [ "${USE_HTTPS}" == "no" ]
			then
				curl -i -X PUT \
				--user ${OPENMNS_USER}:${OPENMNS_PASSWORD} \
				--data "{\"nodeid\": \"${NODE_ID}\"}" \
				http://${MN_FQDN_NAME}/mns/openmn/rest/nbsp/sysinstall/nodeDataStatus
			else
				curl -k -i -X PUT \
				--user ${OPENMNS_USER}:${OPENMNS_PASSWORD} \
				--data "{\"nodeid\": \"${NODE_ID}\"}" \
				https://${MN_FQDN_NAME}/mns/openmn/rest/nbsp/sysinstall/nodeDataStatus
			fi
	
			sleep 1
			echo "OK" >> /var/log/deployment.log
	 
			# Set DB sync to ON
			echo "Activating DB synchronization ... " >> /var/log/deployment.log
			if [ "${USE_HTTPS}" == "no" ]
			then
				curl -i -X PUT \
				--user ${OPENMNS_USER}:${OPENMNS_PASSWORD} \
				--data "{\"nodeid\": \"${NODE_ID}\"}" \
				http://${MN_FQDN_NAME}/mns/openmn/rest/nbsp/sysinstall/dbSyncMode
			else
				curl -k -i -X PUT \
				--user ${OPENMNS_USER}:${OPENMNS_PASSWORD} \
				--data "{\"nodeid\": \"${NODE_ID}\"}" \
				https://${MN_FQDN_NAME}/mns/openmn/rest/nbsp/sysinstall/dbSyncMode
			fi
			sleep 1
			echo "OK" >> /var/log/deployment.log
		fi

		# Get unsynced data
		echo "Getting node's unsynchronized data ... " >> /var/log/deployment.log
		if [ "${USE_HTTPS}" == "no" ]
		then
			curl -i -X PUT \
			--user ${OPENMNS_USER}:${OPENMNS_PASSWORD} \
			--data "{\"nodeid\": \"${NODE_ID}\"}" \
			http://${MN_FQDN_NAME}/mns/openmn/rest/nbsp/sysinstall/refresh
		else
			curl -k -i -X PUT \
			--user ${OPENMNS_USER}:${OPENMNS_PASSWORD} \
			--data "{\"nodeid\": \"${NODE_ID}\"}" \
			https://${MN_FQDN_NAME}/mns/openmn/rest/nbsp/sysinstall/refresh
		fi

		sleep 1
		echo "OK" >> /var/log/deployment.log

		# set active
                echo "Set active release ... " >> /var/log/deployment.log
                if [ "${USE_HTTPS}" == "no" ]
                then
                        curl -i -X PUT \
                        --user ${OPENMNS_USER}:${OPENMNS_PASSWORD} \
                        --data "{\"nodeid\": \"${NODE_ID}\" ,\"neRelease\": \"RESERVED: ${NEW_NE_RELEASE}\"}" \
                        http://${MN_FQDN_NAME}/mns/openmn/rest/nbsp/sysinstall/activeRelease
                else
                        curl -k -i -X PUT \
                        --user ${OPENMNS_USER}:${OPENMNS_PASSWORD} \
                        --data "{\"nodeid\": \"${NODE_ID}\" ,\"neRelease\": \"RESERVED: ${NEW_NE_RELEASE}\"}" \
                        https://${MN_FQDN_NAME}/mns/openmn/rest/nbsp/sysinstall/activeRelease
                fi

                sleep 1
                echo "OK" >> /var/log/deployment.log

		if [ "${sysType}" == "duplicated" ]
                then
			#reboot STB side and wait for it to connect to HSB mode
			echo "Rebooting ${hsbNE}! in 5 sec!" >> /var/log/deployment.log
                        /sbin/ha-exec-cmd --cmd="nohup sh -c 'sleep 5; /sbin/reboot' < /dev/null &> /dev/null &" --host=${hsbNE} --username=root

			# wait for 60 sec and then start checking system state
			sleep 60

			# wait for system to become busy & ACT/STB, DB PRIMARY ACT, mode HSB, DRBD part SYNCHED
                        echo -n "Wait for remote side to become STB, DB PRIMARY ACT, DB MODE HSB, DRBD partitions SYNCHED, APP started ..." >> /var/log/deployment.log

			# preverjaj dolocen cas in ne neskoncno
			i=0
			remote_new_sw_ok="no"
                        while [ $i -lt 600 ]
                        do
                                unit_busy=`/opt/iskratel/bin/sitool --mwd | grep "Unit State:" | grep "BUSY"`
                                local_act=`/opt/iskratel/bin/sitool --mwd | grep "Local Element State:" | grep "ACTIVE"`
                                remote_stb=`/opt/iskratel/bin/sitool --mwd | grep "Remote Element State:" | grep "STANDBY"`
                                db_primary_act=`/opt/iskratel/bin/sitool --dbwd | grep "Database state" | grep "PRIMARY ACTIVE"`
                                db_mode_hsb=`/opt/iskratel/bin/sitool --dbwd | grep "Mode" | grep HSB`

                                drbd_num=`/bin/df -h | grep drbd | wc -l`
                                drbd_num_state_ok=`cat /proc/drbd | grep "cs:Connected" | grep "st:Primary/Secondary" |grep "ds:UpToDate/UpToDate" | wc -l`

				remote_app_running=`/sbin/ha-exec-cmd --cmd="/opt/iskratel/bin/mwdmsgs -s EV_APP_ST_QUERY" --host=$hsbNE --username=root`
				remote_sw_current_link=`/sbin/ha-exec-cmd --cmd="ls -l /opt/si2000/neroot/" --host=$hsbNE --username=root |grep 'current' | rev | cut -d ' ' -f1 | rev`
				remote_sw_active_link=`/sbin/ha-exec-cmd --cmd="ls -l /opt/si2000/neroot/" --host=$hsbNE --username=root |grep 'active' | rev | cut -d ' ' -f1 | rev`
				remote_sw_okay_link=`/sbin/ha-exec-cmd --cmd="ls -l /opt/si2000/neroot/" --host=$hsbNE --username=root |grep 'okay' | rev | cut -d ' ' -f1 | rev`
                                /sbin/ha-exec-cmd --cmd="/sbin/ne_check_hsb_switchover.exp | grep -w -i 'DB SYSTEM STATE'" --host=${hsbNE} --username=root > /tmp/sys_temp
                                /usr/bin/dos2unix /tmp/sys_temp
                                remote_sys_state=`cat /tmp/sys_temp | awk '{print $4}'`
                                if [ "$remote_sys_state" == "ImmediatelySending" ]
                                then
                                        /sbin/ha-exec-cmd --cmd="/sbin/ne_check_hsb_switchover.exp | grep -w -i 'HOT SWITCHOVER POSSIBLE'" --host=${hsbNE} --username=root > /tmp/hsb
                                        /usr/bin/dos2unix /tmp/hsb
                                        hsb_switch_possible=`cat /tmp/hsb`
                                else
                                        hsb_switch_possible="HOT SWITCHOVER POSSIBLE"
                                fi


                                if [ "$unit_busy" != "" ] &&
                                   [ "$local_act" != "" ] &&
                                   [ "$remote_stb" != "" ] &&
                                   [ "$db_primary_act" != "" ] &&
                                   [ "$db_mode_hsb" != "" ] &&
                                   [ $drbd_num -eq $drbd_num_state_ok ] &&
				   [ "$remote_app_running" == "EV_APP_ST_RUNNING" ] &&
				   [ "$remote_sw_current_link" == "$remote_sw_active_link" ] &&
				   [ "$remote_sw_active_link" == "$remote_sw_okay_link" ] &&
				   [ "$hsb_switch_possible" == "HOT SWITCHOVER POSSIBLE" ]
                                then
					remote_new_sw_ok="yes"
                                        break
                                else
                                        echo -n "." >> /var/log/deployment.log
                                        sleep 5
					i=$[i+5]
                                fi
                        done
#                        echo " OK" >> /var/log/deployment.log

			if [ "$remote_new_sw_ok" == "yes" ]
			then
				echo " OK" >> /var/log/deployment.log
				#update config.cfg on new partition
				old_ne_release=`cat $CONFIG | grep 'NE_RELEASE'`
				old_db_release=`cat $CONFIG | grep 'DB_RELEASE'`
				old_data_release=`cat $CONFIG | grep 'DATA_RELEASE'`

				new_ne_release=`cat $UPGRADE_CONFIG | grep 'NEW_NE_RELEASE' | cut -d '=' -f2`
                                new_db_release=`cat $UPGRADE_CONFIG | grep 'NEW_DB_RELEASE' | cut -d '=' -f2`
                                new_data_release=`cat $UPGRADE_CONFIG | grep 'NEW_DATA_RELEASE' | cut -d '=' -f2`

				sed -i -e "s/$old_ne_release/NE_RELEASE=$new_ne_release/g" /upgrade_root/$CONFIG
				sed -i -e "s/$old_db_release/DB_RELEASE=$new_db_release/g" /upgrade_root/$CONFIG
				sed -i -e "s/$old_data_release/DATA_RELEASE=$new_data_release/g" /upgrade_root/$CONFIG

				# copy new config.cfg to hsb remote (STB)
				scp /upgrade_root/$CONFIG root@${hsbNE}:$CONFIG

				# reboot myself and become STB with new SW
				echo "Rebooting ${thisNE} in 5 sec!" >> /var/log/deployment.log
                        	nohup sh -c 'sleep 5; /sbin/reboot' < /dev/null &> /dev/null &
			else
				echo " NOK" >> /var/log/deployment.log

				# remote new sw NOK, switch to previous sw packet and reboot STB
				# set active
		                echo "New SW on remote side NOK - set old SW as active release ... " >> /var/log/deployment.log
		                if [ "${USE_HTTPS}" == "no" ]
		                then
		                        curl -i -X PUT \
		                        --user ${OPENMNS_USER}:${OPENMNS_PASSWORD} \
		                        --data "{\"nodeid\": \"${NODE_ID}\" ,\"neRelease\": \"RESERVED: ${NE_RELEASE}\"}" \
		                        http://${MN_FQDN_NAME}/mns/openmn/rest/nbsp/sysinstall/activeRelease
		                else
		                        curl -k -i -X PUT \
		                        --user ${OPENMNS_USER}:${OPENMNS_PASSWORD} \
		                        --data "{\"nodeid\": \"${NODE_ID}\" ,\"neRelease\": \"RESERVED: ${NE_RELEASE}\"}" \
		                        https://${MN_FQDN_NAME}/mns/openmn/rest/nbsp/sysinstall/activeRelease
		                fi

				#reboot STB side
	                        echo "New SW on remote side NOK - Rebooting ${hsbNE}! in 5 sec!" >> /var/log/deployment.log
	                        /sbin/ha-exec-cmd --cmd="nohup sh -c 'sleep 5; /sbin/reboot' < /dev/null &> /dev/null &" --host=${hsbNE} --username=root

		                sleep 1
		                echo "OK" >> /var/log/deployment.log

				exit 1
			fi
		else
			# reboot myself
			echo "Rebooting ${thisNE} in 5 sec!" >> /var/log/deployment.log
	                nohup sh -c 'sleep 5; /sbin/reboot' < /dev/null &> /dev/null &
		fi

	fi  # end if active element
else
	echo "" >> /var/log/deployment.log
	echo "ERROR: config.cfg or upgrade.cfg does not exist. Can not upgrade system. ABORTING!" >> /var/log/deployment.log
	echo "" >> /var/log/deployment.log

	exit 1
fi

echo "" >> /var/log/deployment.log
echo "##########################" >> /var/log/deployment.log
echo "# cCS SW package upgrade ... END" >> /var/log/deployment.log
echo "##########################" >> /var/log/deployment.log
echo "" >> /var/log/deployment.log

exit 0

